#!/usr/bin/python2.4
# -*- coding: cp1252 -*-
#Su Misura 3D OpenGL, Modellatore/CAD in OpenGL.



print """Su Misura 3D OpenGL, Modellatore/CAD in OpenGL.
"""
print "Sviluppato in Python da Pietro Cona"
print "Sito: www.strutture-forme-colori-movimenti.net"
print "Sotto licenza GPL (Vedi file allegati)"
print "(Visita il sito per maggiori dettagli)"
raw_input("Premi il tasto [Invio] per proseguire")
print


import os
import sys
import anydbm
import Tkinter
import traceback
import tkFileDialog
import webbrowser
#import gestore_proprieta
#from mouseInteractor import MouseInteractor

try:
    from OpenGL.GLUT import *
    from OpenGL.GL import *
    from OpenGL.GLU import *
except:
    print "Errore nell'importazione dei moduli OpenGL"
    sys.exit(  )
import Image
import thread
import threading
dizio_GL={}
dizio_GL["Fin_att"] = 0
dizio_GL["lumin"] = 0.5
dizio_GL["larghe"] = 0.0
dizio_GL["profon"] = 0.0
dizio_GL["altez"] = 0.0

try:
    conten_perc_prog = open("Percorso_del_programma.txt","r+t")
    perc_prog=conten_perc_prog.readline()
    conten_perc_prog.close()
    os.chdir(perc_prog)
    #os.chdir('C:\\Script_in_Python\\Su_Misura_3D_OpenGL_Test')
except:
    nulla=None

#thread.start_new_thread(funzione,tupla di argomenti[,dizionario di argomenti opzionale])
#thread.get_ident()
#thread.exit()


def LoadTextures():
    try:
    	list_file=os.listdir("immagini_materiali\\")
    except:
    	list_file=os.listdir("immagini_materiali/")
    #Create Texture
    try:
        try:
        	image = Image.open("immagini_materiali\\%s"%(list_file[list_comp[dizio["comp_sell"]]["img_textu"]]))
        except:
        	image = Image.open("immagini_materiali/%s"%(list_file[list_comp[dizio["comp_sell"]]["img_textu"]]))
    except:
    	try:
    		#print list_comp
    		list_comp[dizio["comp_sell"]]["img_textu"]=0
        	try:
        		image = Image.open("immagini_materiali\\%s"%(list_file[list_comp[dizio["comp_sell"]]["img_textu"]]))
        	except:
        		image = Image.open("immagini_materiali/%s"%(list_file[list_comp[dizio["comp_sell"]]["img_textu"]]))
        except:
        	image = Image.open("Textur predefinita.jpg")   	
    ix = image.size[0]
    iy = image.size[1]
    image = image.tostring("raw", "RGBX", 0, -1)
    glBindTexture(GL_TEXTURE_2D, glGenTextures(1))   # 2d texture (x and y size)
    glPixelStorei(GL_UNPACK_ALIGNMENT,1)
    glTexImage2D(GL_TEXTURE_2D, 0, 3, ix, iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)


def caric_nuov_textu():
    print "def caric_nuov_textu():"
    perc_nuov_img_textu = tkFileDialog.askopenfilename(filetypes=[("Immagine Jpeg","*.jpg")])
    print perc_nuov_img_textu
    if(perc_nuov_img_textu[0]!="/"):
        perc_nuov_img_textu = perc_nuov_img_textu.replace("/","\\")
        print perc_nuov_img_textu
    print dizio["perc_prog"]
    #dizio["perc_prog"]
    if(perc_nuov_img_textu.find(dizio["perc_prog"])>=0):
        print 'perc_nuov_img_textu.find(dizio["perc_prog"])>=0'
        perc_nuov_img_textu = perc_nuov_img_textu.split(dizio["perc_prog"])[1]
    print perc_nuov_img_textu
    lista_perc_textu.append(perc_nuov_img_textu)
    dizio["tot_num_textu"] += 1
    LoadTextures_2()

def canc_textu_da_list():
    print "def canc_textu_da_list():"
    del lista_perc_textu[textu_sel_num]
    dizio["tot_num_textu"] -= 1
    LoadTextures_2()
    
def LoadTextures_2():
    print "LoadTextures_2():"
    # Create Texture
    lista_textu=[]
    global tut_textu
    print 'dizio["tot_num_textu"] = %s'%(dizio["tot_num_textu"])
    tut_textu_gl = glGenTextures(dizio["tot_num_textu"])
    print tut_textu_gl
    print 'dizio["tot_num_textu"] = %s'%(dizio["tot_num_textu"])
    print "tut_textu_gl = %s"%(tut_textu_gl)
    #print "numero caratteri tut_textu_gl = %s"%(len(tut_textu_gl))
    for num_textu in range(dizio["tot_num_textu"]):
        print num_textu
        print lista_perc_textu
        print lista_perc_textu[num_textu]
        lista_textu.append(Image.open("%s"%(lista_perc_textu[num_textu])))
	ix = lista_textu[num_textu].size[0]
        iy = lista_textu[num_textu].size[1]
        lista_textu[num_textu] = lista_textu[num_textu].tostring("raw", "RGBX", 0, -1)
	#textures = glGenTextures(3)
	#glBindTexture(GL_TEXTURE_2D, int(textures[0]))
        #glBindTexture(GL_TEXTURE_2D, int(tut_textu_gl[num_textu]))
        glBindTexture(GL_TEXTURE_2D, num_textu)
        glPixelStorei(GL_UNPACK_ALIGNMENT,1)
        glTexImage2D(GL_TEXTURE_2D, 0, 3, ix, iy, 0, GL_RGBA, GL_UNSIGNED_BYTE,lista_textu[num_textu])
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
        #glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)

def LoadTextures_sel():
    #print 'def LoadTextures():'
    #global texture
    #image = open("NeHe.bmp")
    #list_comp[dizio["comp_sell"]]["immag_sele"]
    try:
    	list_file=os.listdir("immagini_materiali\\")
    except:
    	list_file=os.listdir("immagini_materiali/")
    #for comp_num in range(num_comp):
    try:
        #print list_file
        #print
        #print list_file[dizio["immag_sele"]]
        try:
        	#list_comp[dizio["comp_sell"]]["img_textu"] = Image.open("immagini_materiali\\%s"%(list_file[list_comp[dizio["comp_sell"]]["id_img_textu"]]))
        	image = Image.open("immagini_materiali\\%s"%(list_file[list_comp[dizio["comp_sell"]]["img_textu"]]))
        	#image = Image.open("immagini_materiali\\%s"%(list_file[dizio["immag_sele"]]))
        except:
        	#list_comp[dizio["comp_sell"]]["img_textu"] = Image.open("immagini_materiali/%s"%(list_file[list_comp[dizio["comp_sell"]]["id_img_textu"]]))
        	image = Image.open("immagini_materiali/%s"%(list_file[list_comp[dizio["comp_sell"]]["img_textu"]]))
        	#image = Image.open("immagini_materiali/%s"%(list_file[dizio["immag_sele"]]))
    except:
        list_comp[dizio["comp_sell"]]["img_textu"]=0
        #dizio["immag_sele"]=0
        try:
        	#list_comp[dizio["comp_sell"]]["img_textu"] = Image.open("immagini_materiali\\%s"%(list_file[list_comp[dizio["comp_sell"]]["id_img_textu"]]))
        	image = Image.open("immagini_materiali\\%s"%(list_file[list_comp[dizio["comp_sell"]]["img_textu"]]))
        	#image = Image.open("immagini_materiali\\%s"%(list_file[dizio["immag_sele"]]))
        except:
        	#list_comp[dizio["comp_sell"]]["img_textu"] = Image.open("immagini_materiali/%s"%(list_file[list_comp[dizio["comp_sell"]]["id_img_textu"]]))
        	image = Image.open("immagini_materiali/%s"%(list_file[list_comp[dizio["comp_sell"]]["img_textu"]]))
        	#image = Image.open("immagini_materiali/%s"%(list_file[dizio["immag_sele"]]))
    #image = Image.open("immagini_materiali\\Marchio_Arredamenti_Cona_Srl_128x128.jpg")
	
    ix = image.size[0]
    iy = image.size[1]
    image = image.tostring("raw", "RGBX", 0, -1)
    # Create Texture
    #glGenTextures(num_comp)
    #for comp_num in range(num_comp):
    #glBindTexture(GL_TEXTURE_2D, glGenTextures(1))   # 2d texture (x and y size)
    glBindTexture(GL_TEXTURE_2D, glGenTextures(1))   # 2d texture (x and y size)
	
    glPixelStorei(GL_UNPACK_ALIGNMENT,1)
    glTexImage2D(GL_TEXTURE_2D, 0, 3, ix, iy, 0, GL_RGBA, GL_UNSIGNED_BYTE, image)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
    #glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)

def costr_3D():
        print 'def costr_3D():'
        #glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT )
        #glLoadIdentity()
	glBegin(GL_QUADS)			    # Start Drawing The Cube
	
	# Front Face (note that the texture's corners have to match the quad's corners)
	glNormal3f( 0.0, 0.0, 0.5)
	#glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0,  1.0)	# Bottom Left Of The Texture and Quad
	glTexCoord2f(0.0, 0.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))
	glTexCoord2f(1.0, 0.0); glVertex3f(((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0, 1.0); glVertex3f(((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Top Right Of The Texture and Quad
	glTexCoord2f(0.0, 1.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Top Left Of The Texture and Quad
	
	# Back Face
	glNormal3f( 0.0, 0.0, -0.5)
	glTexCoord2f(1.0, 0.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0, 1.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Top Right Of The Texture and Quad
	glTexCoord2f(0.0, 1.0); glVertex3f(((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Top Left Of The Texture and Quad
	glTexCoord2f(0.0, 0.0); glVertex3f(((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Bottom Left Of The Texture and Quad
	
	# Top Face
	glNormal3f( 0.0, 0.5, 0.0)
	glTexCoord2f(0.0, 1.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Top Left Of The Texture and Quad
	glTexCoord2f(0.0, 0.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0, 0.0); glVertex3f(((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0, 1.0); glVertex3f(((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Top Right Of The Texture and Quad
	
	# Bottom Face
	glNormal3f( 0.0, -0.5, 0.0)
	glTexCoord2f(1.0, 1.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Top Right Of The Texture and Quad
	glTexCoord2f(0.0, 1.0); glVertex3f( ((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Top Left Of The Texture and Quad
	glTexCoord2f(0.0, 0.0); glVertex3f( ((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0, 0.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Bottom Right Of The Texture and Quad
	
	# Right face
	glNormal3f( 0.5, 0.0, 0.0)
	glTexCoord2f(1.0, 0.0); glVertex3f(((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0, 1.0); glVertex3f(((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Top Right Of The Texture and Quad
	glTexCoord2f(0.0, 1.0); glVertex3f(((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Top Left Of The Texture and Quad
	glTexCoord2f(0.0, 0.0); glVertex3f(((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Bottom Left Of The Texture and Quad
	
	# Left Face
	glNormal3f( -0.5, 0.0, 0.0)
	glTexCoord2f(0.0, 0.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0, 0.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),-((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0, 1.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),((dizio_GL["profon"]/100)/2))	# Top Right Of The Texture and Quad
	glTexCoord2f(0.0, 1.0); glVertex3f(-((dizio_GL["larghe"]/100)/2),((dizio_GL["altez"]/100)/2),-((dizio_GL["profon"]/100)/2))	# Top Left Of The Texture and Quad
	
	glEnd();				# Done Drawing The Cube
	#glPushMatrix()
	#glCallList()
	#glPopMatrix()
        #glutSwapBuffers()
        

def costr_3D_2(comp_num):
        if(dizio["stat_GL_SELECT"]==1):
            #Disegnare la scena dando un nome o pi nomi a ogni oggetto disegnato o un nome a un gruppo di oggetti disegnati
            #glPopName() #toglie il nome in cima allo stack
            glLoadName(comp_num) #sostituisce il nome in cima allo stack con quello dato (equivale a pop seguito da push)
            #print "Componente numero:%s"%(comp_num)
        #print 'def costr_3D_2(comp_num):'
        #glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT )
        #glLoadIdentity()
        #print num_comp
        #print list_comp
        #print comp_num
        #glLoadIdentity()
        #glTranslatef(0,0,0)
        #glTranslatef(list_comp[comp_num]["pos_orig_x"],list_comp[comp_num]["pos_orig_y"],list_comp[comp_num]["pos_orig_z"])
        #glRotatef(0, 1.0, 0.0, 0.0)
        #glRotatef(0, 0.0, 1.0, 0.0)
        #glRotatef(0, 0.0, 0.0, 1.0)
        #glRotatef(list_comp[comp_num]["ang_orig_x"], 1.0, 0.0, 0.0)
        #glRotatef(list_comp[comp_num]["ang_orig_y"], 0.0, 1.0, 0.0)
        #glRotatef(list_comp[comp_num]["ang_orig_z"], 0.0, 0.0, 1.0)
        glBegin(GL_QUADS)			    # Start Drawing The Cube
	
        # Front Face (note that the texture's corners have to match the quad's corners)
        glNormal3f( 0.0, 0.0, 0.5)
        glTexCoord2f(0.0, 0.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glTexCoord2f(1.0, 0.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Right Of The Texture and Quad
        glTexCoord2f(1.0, 1.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Right Of The Texture and Quad
        glTexCoord2f(0.0, 1.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Left Of The Texture and Quad
	
        # Back Face
        glNormal3f( 0.0, 0.0, -0.5)
        glTexCoord2f(1.0, 0.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Right Of The Texture and Quad
        glTexCoord2f(1.0, 1.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Right Of The Texture and Quad
        glTexCoord2f(0.0, 1.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Left Of The Texture and Quad
        glTexCoord2f(0.0, 0.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Left Of The Texture and Quad
	
        # Top Face
        glNormal3f( 0.0, 0.5, 0.0)
        glTexCoord2f(0.0, 1.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Left Of The Texture and Quad
        glTexCoord2f(0.0, 0.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Left Of The Texture and Quad
        glTexCoord2f(1.0, 0.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Right Of The Texture and Quad
        glTexCoord2f(1.0, 1.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Right Of The Texture and Quad
	
        # Bottom Face
        glNormal3f( 0.0, -0.5, 0.0)
        glTexCoord2f(1.0, 1.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Right Of The Texture and Quad
        glTexCoord2f(0.0, 1.0); glVertex3f( ((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                    -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Left Of The Texture and Quad
        glTexCoord2f(0.0, 0.0); glVertex3f( ((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                    ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Left Of The Texture and Quad
        glTexCoord2f(1.0, 0.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Right Of The Texture and Quad
	
        # Right face
        glNormal3f( 0.5, 0.0, 0.0)
        glTexCoord2f(1.0, 0.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Right Of The Texture and Quad
        glTexCoord2f(1.0, 1.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Right Of The Texture and Quad
        glTexCoord2f(0.0, 1.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Left Of The Texture and Quad
        glTexCoord2f(0.0, 0.0); glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Left Of The Texture and Quad
	
        # Left Face
        glNormal3f( -0.5, 0.0, 0.0)
        glTexCoord2f(0.0, 0.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Left Of The Texture and Quad
        glTexCoord2f(1.0, 0.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Bottom Right Of The Texture and Quad
        glTexCoord2f(1.0, 1.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   ((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Right Of The Texture and Quad
        glTexCoord2f(0.0, 1.0); glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),\
                                                   -((list_comp[comp_num]["dim_comp_P"]/100)/2))	# Top Left Of The Texture and Quad
	
        glEnd();				# Done Drawing The Cube
        #print comp_num
        #glPushMatrix()
        #glCallList()
        #glPopMatrix()
        #glutSwapBuffers()

def dis_libero(comp_num):
        #Struttura principale  file_db["id_img_textu,%s"%(comp_num)]=str(list_comp[comp_num]["comp_liber"])
        """GL_POINTS,GL_LINES,GL_LINE_STRIP,GL_LINE_LOOP,GL_TRIANGLES,GL_TRIANGLE_STRIP,GL_TRIANGLE_FAN,GL_QUADS,GL_QUAD_STRIP,GL_POLYGON"""
        #list_comp[comp_num]["strut"]={"facc1":{"id-img":0,"pi_ve0":[{"pix":0.0,"piy":0.0},{"vx":0.0,"vy":0.0,"vz":0.0}],"pi_ve1":[{"pix":0.0,"piy":0.0},\
        #{"vx":0.0,"vy":0.0,"vz":0.0}],"pi_ve2":[{"pix":0.0,"piy":0.0},{"vx":0.0,"vy":0.0,"vz":0.0}],"pi_ve3":[{"pix":0.0,"piy":0.0},{"vx":0.0,"vy":0.0,\
        #"vz":0.0}]}},{"facc2":{"id-img":0,"pi_ve0":[{"pix":0.0,"piy":0.0},{"vx":0.0,"vy":0.0,"vz":0.0}],"pi_ve1":[{"pix":0.0,"piy":0.0},{"vx":0.0,\
        #"vy":0.0,"vz":0.0}],"pi_ve2":[{"pix":0.0,"piy":0.0},{"vx":0.0,"vy":0.0,"vz":0.0}]}}
        list_comp[comp_num]["strut"]={"facc1":{"id-img":0,"pi_ve0":[{"pix":0.0,"piy":0.0},{"vx":-1.0,"vy":-1.0,"vz":1.0}],"pi_ve1":[{"pix":0.0,"piy":0.0},\
            {"vx":0.0,"vy":0.0,"vz":0.0}],"pi_ve2":[{"pix":0.0,"piy":0.0},{"vx":0.0,"vy":0.0,"vz":0.0}],"pi_ve3":[{"pix":0.0,"piy":0.0},{"vx":0.0,"vy":0.0,\
            "vz":0.0}]}},{"facc2":{"id-img":0,"pi_ve0":[{"pix":0.0,"piy":0.0},{"vx":0.0,"vy":0.0,"vz":0.0}],"pi_ve1":[{"pix":0.0,"piy":0.0},{"vx":0.0,\
            "vy":0.0,"vz":0.0}],"pi_ve2":[{"pix":0.0,"piy":0.0},{"vx":0.0,"vy":0.0,"vz":0.0}]}}
        list_comp[comp_num]["strut"]=[[0,[[0.0,0.0],[0.0,0.0,0.0]],[[0.0,0.0],[0.0,0.0,0.0]],[[0.0,0.0],[0.0,0.0,0.0]],[[0.0,0.0],[0.0,0.0,0.0]]],\
                    [1,[[0.0,0.0],[0.0,0.0,0.0]],[[0.0,0.0],[0.0,0.0,0.0]],[[0.0,0.0],[0.0,0.0,0.0]]]]
        #nx,ny,nz,pix,piy=0.0
        #nv=0
        prec_tip_fac = None
        if(dizio["stat_GL_SELECT"]==1):
            glLoadName(comp_num)
        #glBegin(GL_TRIANGLES)
        num_facce = str(list_comp[comp_num]["strut"].keys()).count("facc")
        for fac in range(num_facce):
            faccia = list_comp[comp_num]["strut"]["facc%s"%(fac+1)]
            num_ve_fac = str(faccia.keys()).count("pi_ve")
            if(num_ve_fac==3):
                if(prec_tip_fac!=3 and prec_tip_fac!=None):
                    glEnd();
                if(prec_tip_fac!=3):
                    glBegin(GL_TRIANGLES)
                    prec_tip_fac = 3
                glNormal3f(nx,ny,nz)
                for nv in range(3):
                    pi_ve = faccia["pi_ve%s"%(nv)]
                    glTexCoord2f(pi_ve[0]["pix"],pi_ve[0]["piy"]);glVertex3f(pi_ve[1]["vx"],pi_ve[1]["vy"],pi_ve[1]["vz"])
            if(num_ve_fac==4):
                if(prec_tip_fac!=4 and prec_tip_fac!=None):
                    glEnd();
                if(prec_tip_fac!=4):
                    glBegin(GL_QUADS)
                    prec_tip_fac = 4
                glNormal3f(nx,ny,nz)
                for nv in range(4):
                    pi_ve = faccia["pi_ve%s"%(nv)]
                    glTexCoord2f(pi_ve[0]["pix"],pi_ve[0]["piy"]);glVertex3f(pi_ve[1]["vx"],pi_ve[1]["vy"],pi_ve[1]["vz"])
        glEnd();

def curve_3D():
        # Inizio prove temporanee
        glBegin(GL_QUADS)
        glNormal3f( 0.0, 0.0, 0.5)
        glTexCoord2f(0.0, 0.0); glVertex3f(0.0,0.0,0.0)
        glTexCoord2f(0.5, 0.0); glVertex3f(1.0,0.0,0.0)
        glTexCoord2f(0.5, 1.0); glVertex3f(1.0,1.0,0.0)
        glTexCoord2f(0.0, 1.0); glVertex3f(0.0,1.0,0.0)
        glNormal3f( 0.0, 0.0, 0.5)
        glTexCoord2f(0.5, 0.0); glVertex3f(1.0,0.0,0.0)
        glTexCoord2f(1.0, 0.0); glVertex3f(2.0,0.0,-1.0)
        glTexCoord2f(1.0, 1.0); glVertex3f(2.0,1.0,-1.0)
        glTexCoord2f(0.5, 1.0); glVertex3f(1.0,1.0,0.0)
        glEnd();
        # Fine prove temporanee

def costr_3D_linee(comp_num): 
        glBegin(GL_LINES)
        #Faccia frontale
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        #Faccia posteriore
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        #Faccia superiore
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        #Faccia inferiore
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f( ((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f( ((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        #Faccia destra
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        #Faccia sinistra
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),-((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glVertex3f(-((list_comp[comp_num]["dim_comp_L"]/100)/2),((list_comp[comp_num]["dim_comp_H"]/100)/2),-((list_comp[comp_num]["dim_comp_P"]/100)/2))
        glEnd()

def assi(R,G,B,A):
    #print 'def assi():'
    BR,BG,BB=R,G,B
    if(dizio["asse_sell"]==0 and A==1):
        R,G,B=0,1,0
    glColor3f(R,G,B)
    R,G,B=BR,BG,BB
    glRasterPos3f(dizio["dim_ass"],0,0)
    for c in ("+X"):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(-dizio["dim_ass"],0,0)
    for c in ("-X"):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    if(dizio["asse_sell"]==1 and A==1):
        R,G,B=0,1,0
    glColor3f(R,G,B)
    R,G,B=BR,BG,BB
    glRasterPos3f(0,dizio["dim_ass"],0)
    for c in ("+Y"):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(0,-dizio["dim_ass"],0)
    for c in ("-Y"):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    if(dizio["asse_sell"]==2 and A==1):
        R,G,B=0,1,0
    glColor3f(R,G,B)
    R,G,B=BR,BG,BB
    glRasterPos3f(0,0,dizio["dim_ass"])
    for c in ("+Z"):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(0,0,-dizio["dim_ass"])
    for c in ("-Z"):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glBegin(GL_LINES)
    if(dizio["asse_sell"]==0 and A==1):
        R,G,B=0,1,0
    glColor3f(R,G,B)
    R,G,B=BR,BG,BB
    glVertex3f(-dizio["dim_ass"],0,0)#asse delle X
    glVertex3f(dizio["dim_ass"],0,0)
    if(dizio["asse_sell"]==1 and A==1):
        R,G,B=0,1,0
    glColor3f(R,G,B)
    R,G,B=BR,BG,BB
    glVertex3f(0,-dizio["dim_ass"],0)#asse delle Y
    glVertex3f(0,dizio["dim_ass"],0)
    if(dizio["asse_sell"]==2 and A==1):
        R,G,B=0,1,0
    glColor3f(R,G,B)
    R,G,B=BR,BG,BB
    glVertex3f(0,0,-dizio["dim_ass"])#asse delle Z
    glVertex3f(0,0,dizio["dim_ass"])
    glEnd()
    #glEnable( GL_LIGHTING )

def vis_id_ogg(comp_num):
    #nulla=None
    if(dizio["vis_num_ID"]==1):
        glDisable( GL_LIGHTING )
        glDisable(GL_TEXTURE_2D)
        glColor3f( 0, 1, 0)
        glRasterPos3f(0,0,0)
        for c in (str(comp_num)):
            glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
        glEnable(GL_TEXTURE_2D)
        glEnable(GL_LIGHTING)

# new window size or exposure
def reshape(width, height):
        dizio["larg_fin"]=width
        dizio["alt_fin"]=height
        #print 'def reshape(width, height):'
        h = float(height) / float(width);
        glViewport(0, 0, width, height)
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()
        glFrustum(-1.0, 1.0, -h, h, 5.0, 60.0)
        glMatrixMode(GL_MODELVIEW)
        glLoadIdentity()
        glTranslatef(0.0, 0.0, -4.0)
        glRotatef(0,1,1,1)
        
def display():
    #dizio["tasto_comb"] = glutGetModifiers()
    #print "Tasto_comb = %s"%(dizio["tasto_comb"])
    #print'def display():'
    #glSelectBuffer(512) #Crea il selection buffer 
    #dizio["stat_GL_SELECT"]=1
    #Sistema per selezionare oggetti col mouse
    #glRenderMode(GL_SELECT) #entrara in selection mode
    try:
        if(dizio["stat_GL_SELECT"]==1):
            #print "Esecuzione disegno in modalit selezione"
            glSelectBuffer(512) #Crea il selection buffer
            glRenderMode(GL_SELECT) #entra in selection mode
            glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT )
            glMatrixMode( GL_PROJECTION )
            glLoadIdentity()
            viewport = glGetIntegerv(GL_VIEWPORT)
            gluPickMatrix(dizio["x_me"],dizio["alt_fin"]-dizio["y_me"],1,1,viewport)#restringe l'area di selezione, va chiamata subito dopo glMatrixMode(GL_PROJECTION); glLoadIdentity();
            glInitNames() #inizializza lo stack dei nomi a vuoto
            glPushName(0) #aggiunge un nome in cima allo stack
            display_2()
            #N = glRenderMode(GL_RENDER) #Torna in rendering mode e ritorna in N il numero di hit generati  795
            hits = glRenderMode(GL_RENDER)
            try:
                hitlist = []
                hitlist = [hit[2][0] for hit in hits]
                #glRenderMode(GL_RENDER)
                #Leggere il selection buffer (N)
                #print
                #print hits
                #print hits[1]
                #print hits[1][2]
                #print hits[1][2][0]
                print hitlist
                dizio["comp_sell"]=hitlist[0]
            except:
                nulla=None
                #traceback.print_exc()
    except:
        nulla=None
    dizio["stat_GL_SELECT"]=0
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT )
    glMatrixMode( GL_PROJECTION )
    glLoadIdentity()
    display_2()
    glutSwapBuffers( )

def display_2():
    #print'def display_2():'
    xSize, ySize = glutGet( GLUT_WINDOW_WIDTH ), glutGet( GLUT_WINDOW_HEIGHT )
    try:
        #gluOrtho2D(-1.5,+1.5,-1.5,1.5)
        if(dizio["stat_prospetiva"]==1):
            gluPerspective(dizio["cono_prosp"], float(xSize) / float(ySize), 0.1, 50)
        else:
            glOrtho(-2,+2,-1,1,-2,2)
    except:
        nulla = None
    glMatrixMode( GL_MODELVIEW )
    #if(dizio["stat_spost_iniz"]==1):
    #    print "Esecuzione spostamento iniziale"
    #    glTranslatef(0,0,-4)
    #    dizio["stat_spost_iniz"]=0
    glDisable( GL_LIGHTING )
    glDisable(GL_TEXTURE_2D)
    if(dizio["color_sfond"]==255):
        glColor3f(0,0,0)
    else:
        glColor3f(1,1,1)
    #glColor3f(1,1,1)
    #glColor3f( 1, 1, 0.3 )
    glLoadIdentity()
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"],-0.1)
    for c in ("[H] = Guida"):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.005,-0.1)
    for c in ("Valore illuminazione: "+str(dizio_GL["lumin"])):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.010,-0.1)
    for c in ("Cono prospettico: "+str(dizio["cono_prosp"])):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.015,-0.1)
    for c in ("Rotazione attorno asse X: "+str(dizio["angolo_visual_X"])):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.020,-0.1)
    for c in ("Rotazione attorno asse Y: "+str(dizio["angolo_visual_Y"])):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.025,-0.1)
    for c in ("Modalita: "+str(dizio["modalita"])):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    if(dizio["vinc_facc"]==1):
        desc_vinc = "Vincolo faccia verso: %s"%("-")
    if(dizio["vinc_facc"]==2):
        desc_vinc = "Vincolo faccia verso: %s"%("+")
    if(dizio["vinc_facc"]==0):
        desc_vinc = "Vincolo %s"%("centrale")
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.030,-0.1)
    for c in (desc_vinc):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    #prez_ogg = calc_prez()
    #glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.6,-4)
    #for c in ("Tot. Euro: "+str(tot_prez)):
    #    glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glEnable(GL_TEXTURE_2D)
    glEnable( GL_LIGHTING )
    #compon["Nom_est_prod"]
    #glRotatef(0,1,1,1)
    glLoadIdentity()
    glTranslatef(dizio["pos_visual_X"],dizio["pos_visual_Y"],dizio["dist_osserv"])
    glRotatef(dizio["angolo_visual_X"],1,0,0)
    #print dizio["angolo_visual_X"]
    glRotatef(dizio["angolo_visual_Y"],0,1,0)
    if(dizio["stat_dim_glob"]==1):
        glDisable( GL_LIGHTING )
        glDisable(GL_TEXTURE_2D)
        #glColor3f( 1, 1, 0.3 )
        if(dizio["color_sfond"]==255):
            glColor3f(0,0,0)
        else:
            glColor3f(1,1,1)
        glRasterPos3f(0,-dizio_GL["altez"]/100/2,dizio_GL["profon"]/100/2)
        for c in (str(dizio_GL["larghe"])):
            glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
        glRasterPos3f(dizio_GL["larghe"]/100/2,0,-dizio_GL["profon"]/100/2)
        for c in (str(dizio_GL["altez"])):
            glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
        glTranslatef(0,0,0)
        glRasterPos3f(dizio_GL["larghe"]/100/2,-dizio_GL["altez"]/100/2,0)
        for c in (str(dizio_GL["profon"])):
            glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
        glEnable(GL_TEXTURE_2D)
        glEnable( GL_LIGHTING )
    tot_prez = 0
    #print dizio["angolo_visual_Y"]
    #curve_3D()
    for comp_num in range(num_comp):
        #if(dizio["stat_GL_SELECT"]==1):
        #    #Disegnare la scena dando un nome o pi nomi a ogni oggetto disegnato o un nome a un gruppo di oggetti disegnati
        #    #glPopName() #toglie il nome in cima allo stack
        #    glLoadName(comp_num) #sostituisce il nome in cima allo stack con quello dato (equivale a pop seguito da push)
        #    #print "Componente numero:%s"%(comp_num)
        #glBindTexture(GL_TEXTURE_2D, int(textures[texture_num]))
        #glBindTexture(GL_TEXTURE_2D, int(tut_textu_gl[list_comp[comp_num]["id_img_textu"]])) #Assegna la texture corrispondente ad un determinato componente
        try:
            #print list_comp[comp_num]["id_img_textu"]
            glBindTexture(GL_TEXTURE_2D, list_comp[comp_num]["id_img_textu"]) #Assegna la texture corrispondente ad un determinato componente
        except:
            nulla=None
            print "Errore in glBindTexture"
            traceback.print_exc()
        #print list_comp[comp_num]["id_img_textu"]+1
        glLoadIdentity()
        #print dizio["comp_sell"],comp_num
        if(dizio["comp_sell"]==comp_num):
            glDisable(GL_LIGHTING)
            glDisable(GL_TEXTURE_2D)
            #glColor3f( 1, 1, 0.3 )
            if(dizio["color_sfond"]==255):
                glColor3f(0,0,0)
            else:
                glColor3f(1,1,1)
            glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.035,-0.1)
            for c in ("Componente: "+str(list_comp[comp_num]["Nom_est_prod"])):
                glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
            glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.040,-0.1)
            for c in ("Larghezza: "+str(list_comp[comp_num]["dim_comp_L"])):
                glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
            glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.045,-0.1)
            for c in ("Profondit: "+str(list_comp[comp_num]["dim_comp_P"])):
                glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
            glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.050,-0.1)
            for c in ("Altezza: "+str(list_comp[comp_num]["dim_comp_H"])):
                glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
            prez_ogg = (float(list_comp[comp_num]["dim_comp_L"])/100)*(float(list_comp[comp_num]["dim_comp_H"])/100)*dizio["prez_mq"]
            glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.055,-0.1)
            for c in ("Prezzo elemento: Euro "+str(prez_ogg)):
                glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
            glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.060,-0.1)
            for c in ("Prezzo al m: Euro "+str(dizio["prez_mq"])):
                glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
            glEnable(GL_TEXTURE_2D)
            glEnable(GL_LIGHTING)
        glLoadIdentity()
        glTranslatef(dizio["pos_visual_X"],dizio["pos_visual_Y"],dizio["dist_osserv"])
        glRotatef(dizio["angolo_visual_X"],1,0,0)
        glRotatef(dizio["angolo_visual_Y"],0,1,0)
        #glRotatef(10.0,1.0,0.0,0.0)
        #glRotatef(10.0,0.0,1.0,0.0)
        #glRotatef(10.0,0.0,0.0,1.0)
        #glRotatef(list_comp[comp_num]["ang_orig_x"],1.0,0.0,0.0)
        #glRotatef(list_comp[comp_num]["ang_orig_y"],0.0,1.0,0.0)
        #glRotatef(list_comp[comp_num]["ang_orig_z"],0.0,0.0,1.0)
        #glLoadIdentity( )
        #glTranslatef(0,0,-4)
        #print xSize
        #if(dizio["stat_mouse"]==1):
        #   global mouseInteractor
        #   mouseInteractor.applyTransformation( )
        
        #glCallList( tkList )
        #costr_3D()   
        #glRotatef(10.0,1.0,0.0,0.0)
        #glRotatef(10.0,0.0,1.0,0.0)
        #glRotatef(10.0,0.0,0.0,1.0)
        glTranslatef(list_comp[comp_num]["pos_orig_x"],list_comp[comp_num]["pos_orig_y"],list_comp[comp_num]["pos_orig_z"])
        if(dizio["comp_sell"]==comp_num and dizio["stat_assi_2"]==1):
        #if(dizio["stat_assi_2"]==1):
            glDisable(GL_LIGHTING)
            glDisable(GL_TEXTURE_2D)
            #assi_ogg()
            R,G,B,A=1,0,0,0
            if(dizio["grup_assi_sell"]==1):
                A=1
            assi(R,G,B,A)
            glEnable(GL_TEXTURE_2D)
            glEnable(GL_LIGHTING)
        #print list_comp[comp_num]["ang_orig_x"]
        glRotatef(list_comp[comp_num]["ang_orig_x"],1.0,0.0,0.0)
        glRotatef(list_comp[comp_num]["ang_orig_y"],0.0,1.0,0.0)
        glRotatef(list_comp[comp_num]["ang_orig_z"],0.0,0.0,1.0)
        #list_comp[dizio["comp_sell"]]["pos_orig_2_x"]
        glTranslatef(list_comp[comp_num]["pos_orig_2_x"],list_comp[comp_num]["pos_orig_2_y"],list_comp[comp_num]["pos_orig_2_z"])
        #print dizio["comp_sell"],comp_num
        #if(dizio["comp_sell"]==comp_num and dizio["modalita"]==2):
        if(dizio["comp_sell"]==comp_num and dizio["stat_assi_3"]==1):
            glDisable(GL_LIGHTING)
            glDisable(GL_TEXTURE_2D)
            #assi_ogg_2()
            R,G,B,A=1,0,1,0
            if(dizio["grup_assi_sell"]==2):
                A=1
            assi(R,G,B,A)
            glEnable(GL_TEXTURE_2D)
            glEnable(GL_LIGHTING)
        if(dizio["modalita"]==1):
            if(dizio["att_costr_3D_2"]==1):
                vis_id_ogg(comp_num)
                costr_3D_2(comp_num)
            if(dizio["att_costr_3D_linee"]==1):
                vis_id_ogg(comp_num)
                glDisable( GL_LIGHTING )
                glDisable(GL_TEXTURE_2D)
                #glColor3f(1,1,1)
                if(dizio["color_sfond"]==255):
                    glColor3f(0,0,0)
                else:
                    glColor3f(1,1,1)
                #costr_3D_2(comp_num)
                glLineWidth(2.0)
                costr_3D_linee(comp_num)
                glLineWidth(1.0)
                glEnable(GL_TEXTURE_2D)
                glEnable(GL_LIGHTING)
                #costr_3D_2(comp_num)
        if(dizio["modalita"]==5):
            #vis_id_ogg(comp_num)
            costr_3D_2(comp_num)
        if(dizio["modalita"]==2 and dizio["comp_sell"]==comp_num):
            vis_id_ogg(comp_num)
            glDisable(GL_LIGHTING)
            glDisable(GL_TEXTURE_2D)
            glColor3f(0,0,1)
            #costr_3D_2(comp_num)
            glLineWidth(2.0)
            costr_3D_linee(comp_num)
            glLineWidth(1.0)
            glEnable(GL_TEXTURE_2D)
            glEnable(GL_LIGHTING)
            costr_3D_2(comp_num)
        elif(dizio["modalita"]==2 and dizio["comp_sell"]!=comp_num):
            vis_id_ogg(comp_num)
            costr_3D_2(comp_num)
        if(dizio["modalita"]==3 and dizio["comp_sell"]==comp_num):
            vis_id_ogg(comp_num)
            glDisable(GL_LIGHTING)
            glDisable(GL_TEXTURE_2D)
            glColor3f(0,0,1)
            #costr_3D_2(comp_num)
            glLineWidth(2.0)
            costr_3D_linee(comp_num)
            glLineWidth(1.0)
            glEnable(GL_TEXTURE_2D)
            glEnable(GL_LIGHTING)
            costr_3D_2(comp_num)
        elif(dizio["modalita"]==3 and dizio["comp_sell"]!=comp_num):
            vis_id_ogg(comp_num)
            costr_3D_2(comp_num)
        if(dizio["comp_sell"]==comp_num and dizio["modalita"]==2 or dizio["modalita"]==3 ):
            glEnable(GL_TEXTURE_2D)
            glEnable(GL_LIGHTING)
        prez_ogg = calc_prez(comp_num)
        tot_prez+=prez_ogg
    if(dizio["stat_assi_1"]==1):
        glLoadIdentity()
        glTranslatef(dizio["pos_visual_X"],dizio["pos_visual_Y"],dizio["dist_osserv"])
        glRotatef(dizio["angolo_visual_X"],1,0,0)
        glRotatef(dizio["angolo_visual_Y"],0,1,0)
        glDisable(GL_LIGHTING)
        glDisable(GL_TEXTURE_2D)
        #glColor3f(1,1,0)
        #assi_prim()
        R,G,B,A=1,0.5,0,0
        if(dizio["grup_assi_sell"]==0):
            A=1
        assi(R,G,B,A)
        glEnable(GL_TEXTURE_2D)
        glEnable(GL_LIGHTING)
    glDisable(GL_LIGHTING)
    glDisable(GL_TEXTURE_2D)
    glLoadIdentity()
    #glColor3f( 1, 1, 0.3 )
    if(dizio["color_sfond"]==255):
        glColor3f(0,0,0)
    else:
        glColor3f(1,1,1)
    dizio["tot_prez"]=tot_prez
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.065,-0.1)
    for c in ("Tot. Euro: "+str(tot_prez)):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.070,-0.1)
    for c in ("Descrizione: "+str(dizio["descrizioni"])):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glRasterPos3f(dizio["pos_scrite_X"],dizio["pos_scrite_Y"]-0.075,-0.1)
    for c in ("Digitazione: "+str(dizio["digitazioni"])):
        glutBitmapCharacter( GLUT_BITMAP_TIMES_ROMAN_24, ord(c) )
    glEnable(GL_TEXTURE_2D)
    glEnable(GL_LIGHTING)

def init():
        print'def init():'
	"""Glut init function."""
	try:
            glutSetWindowTitle("%s    (Su Misura 3D OpenGL TEST - www.strutture-forme-colori-movimenti.net)"%(dizio["file_dat_antep_3D_db"]))
        except:
            glutSetWindowTitle("Nessun file aperto    (Su Misura 3D OpenGL - www.strutture-forme-colori-movimenti.net)")
        #try:
        #    list_file=os.listdir("immagini_materiali\\")
        #except:
        #    list_file=os.listdir("immagini_materiali/")
        #for comp_num in range(num_comp):
        #    ix,iy,image = LoadTextures(comp_num,list_file)
        #    Textur_iniz(ix,iy,image)
        try:
            LoadTextures_2()
        except:
            traceback.print_exc()
            nulla=None
	#LoadTextures()
	#glSelectBuffer(512) #Crea il selection buffer
	#glEnable(GL_BLEND)
	#glBlendFunc(GL_SRC_ALPHA, GL_ONE)
	
	#Sistema per selezionare oggetti col mouse
	#glSelectBuffer(512) #Crea il selection buffer 
	#glRenderMode(GL_SELECT) #entrara in selection mode
	#gluPickMatrix(x,y,w,h,viewport) #restringe l'area di selezione, va chiamata subito dopo glMatrixMode(GL_PROJECTION); glLoadIdentity();
	#Disegnare la scena dando un nome o pi nomi a ogni oggetto disegnato o un nome a un gruppo di oggetti disegnati
	#glInitNames() #inizializza lo stack dei nomi a vuoto
	#glPushName(int nome) #aggiunge un nome in cima allo stack
	#glPopName() #toglie il nome in cima allo stack
	#glLoadName(int nome) #sostituisce il nome in cima allo stack con quello dato (equivale a pop seguito da push)
	#N = glRenderMode(GL_RENDER) #Torna in rendering mode e ritorna in N il numero di hit generati
	#Leggere il selection buffer (N)
	
	glEnable(GL_TEXTURE_2D)
	#glClearColor ( 0, 0, 0, 0 )
	glClearColor(dizio["color_sfond"],dizio["color_sfond"],dizio["color_sfond"], 0 )
	glEnable( GL_DEPTH_TEST )
	glShadeModel( GL_SMOOTH )
	glEnable( GL_LIGHTING )
	glEnable( GL_LIGHT0 )
	glLightModeli( GL_LIGHT_MODEL_TWO_SIDE, 0 )
	glLightfv( GL_LIGHT0, GL_POSITION, [4, 4, 4, 1] )
	lA = 0.8
	glLightfv( GL_LIGHT0, GL_AMBIENT, [lA, lA, lA, 1] )
	lD = 1
	glLightfv( GL_LIGHT0, GL_DIFFUSE, [lD, lD, lD, 1] )
	lS = 1
	glLightfv( GL_LIGHT0, GL_SPECULAR, [lS, lS, lS, 1] )
	#glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, [0.0, 0.0, 0.2, 1] )
	#glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE, [0.0, 0.0, 0.7, 1] )
	#glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR, [0.5, 0.5, 0.5, 1] )
	glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, [dizio_GL["lumin"],dizio_GL["lumin"],dizio_GL["lumin"], 0.5] )
	glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE, [1,1,1, 0.5] )
	glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR, [0.5,0.5,0.5, 0.5] )
	glMaterialf( GL_FRONT_AND_BACK, GL_SHININESS, 50 )
	#global mouseInteractor
	#mouseInteractor = MouseInteractor( .01, 1 )
	#global tkList
	#tkList = glGenLists(1)
	#glNewList(tkList,GL_COMPILE)
	#glutSolidTeapot(1.0)
	#costr_3D()
	#glEndList()

def tasto_special_2(k):
    print "Valore premuto = %s"%(k)
    nulla=None
    if k ==0:
        print "Passato per Valore 0"
        #glutPostRedisplay()

def tasto_special(k, x, y):
    dizio["tasto_comb"] = glutGetModifiers()
    #print "Tasto_comb = %s"%(dizio["tasto_comb"])
    #tasto_comb = glutGetModifiers()
    #print tasto_comb
    #print "Valore premuto = %s"%(k)
    nulla=None
    if k ==1:
        apri_file_3D_db()
        glutPostRedisplay()
    if k ==2:
        salva_c_n_file_3D_db()
        glutPostRedisplay()
    if k ==3:
        valore=float(input("digita prezzo al MQ: "))
        print valore
        dizio["prez_mq"]=valore
        file_db = anydbm.open(dizio["file_dat_antep_3D_db"],"c")
        file_db["prez_mq"]=str(valore)
        file_db.close()
        #imp_Prod_OGL = anydbm.open("Impostazioni_di_Prodotto_OpenGL","c")
        #imp_Prod_OGL["prez_mq"]=str(valore)
        #imp_Prod_OGL.close()
        glutPostRedisplay()
    if k ==4:
        if(dizio["att_costr_3D_2"]==1):
            dizio["att_costr_3D_2"]=0
        else:
            dizio["att_costr_3D_2"]=1
        glutPostRedisplay()
    if k ==5:
        if(dizio["att_costr_3D_linee"]==1):
            dizio["att_costr_3D_linee"]=0
        else:
            dizio["att_costr_3D_linee"]=1
        glutPostRedisplay()
    if k ==6:
        stamp__dettagl_prez()
        glutPostRedisplay()
    if k ==7:
        rinomina_elem()
        glutPostRedisplay()
    if k ==8:
        caric_nuov_textu()
        glutPostRedisplay()
    if k ==9:
        canc_textu_da_list()
        glutPostRedisplay()
    if k ==10:
        dizio["descrizioni"]="Alterna sfondo bianco e sfondo nero"
        if(dizio["color_sfond"]==255):
            dizio["color_sfond"]=0
        else:
            dizio["color_sfond"]=255
	glClearColor(dizio["color_sfond"],dizio["color_sfond"],dizio["color_sfond"], 0 )
        glutPostRedisplay()
    if k ==11:
        dizio["descrizioni"]="Visualizza gestore propriet"
        gestore_proprieta()
        #thread.start_new_thread(gestore_proprieta,())
        #nuov_thread=threading.Thread(target=gestore_proprieta)
        #nuov_thread.start()
        #dizio["id_thread"] = thread.get_ident()
        #print "Thread n. ",dizio["id_thread"]
        #thread.exit_thread()
        #thread.exit()
        glutPostRedisplay()
    if k ==102:
        dizio["comp_sell"]+=1
        if(dizio["comp_sell"]>=dizio["num_tot_comp"]):
            dizio["comp_sell"]=0
        #print dizio["comp_sell"]
        try:dizio_gest_prop["Nom_ogg"].set(list_comp[dizio["comp_sell"]]["Nom_est_prod"])
        except: nulla=None
        glutPostRedisplay()
    if k ==100:
        dizio["comp_sell"]-=1
        if(dizio["comp_sell"]<0):
            dizio["comp_sell"]=dizio["num_tot_comp"]-1
        #print dizio["comp_sell"]
        try:dizio_gest_prop["Nom_ogg"].set(list_comp[dizio["comp_sell"]]["Nom_est_prod"])
        except:nulla=None
        glutPostRedisplay()
    if k ==101:
        #print "aumenta l'illuminazione"
        dizio_GL["lumin"]+=0.01
        #print "Valore illuminazione = %s"%(dizio_GL["lumin"])
	glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, [dizio_GL["lumin"],dizio_GL["lumin"],dizio_GL["lumin"], 0.5] )
        glutPostRedisplay()
    if k ==103:
        #print "diminuisce l'illuminazione"
        dizio_GL["lumin"]-=0.01
        #print "Valore illuminazione = %s"%(dizio_GL["lumin"])
	glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT, [dizio_GL["lumin"],dizio_GL["lumin"],dizio_GL["lumin"], 0.5] )
        glutPostRedisplay()
        
def gestore_proprieta():
    #global dizio_gest_prop
    #dizio_gest_prop={}
    #root=Tkinter.Tk()
    #dizio_gest_prop["Nom_ogg"] = Tkinter.StringVar()
    #dizio_gest_prop["Nom_ogg"].set(list_comp[dizio["comp_sell"]]["Nom_est_prod"])
    #global list_comp
    #print list_comp[dizio["comp_sell"]]["Nom_est_prod"]
    #global list_comp
    #import gestore_proprieta
    gestore_proprieta=open("gestore_proprieta.py","r+t")
    exec gestore_proprieta
    print "Dopo exec gestore_proprieta"
    #dizio_gest_prop["o18"].destroy()
    #root.destroy()
    #thread.exit_thread()
    #thread.exit()
    #root.mainloop()

def tasto(k, x, y):
    #print "hai premuto un tasto sulla Finestra OpenGL"
    #tasto_comb = glutGetModifiers()
    #print tasto_comb
    dizio["tasto_comb"] = glutGetModifiers()
    #print "Tasto_comb = %s"%(dizio["tasto_comb"])
    #print "Tasto premuto = %s"%(k)
    if(dizio["mod_digit"]==0):
        #dizio["descrizioni"] = ""
        tasto_1(k, x, y)
    if(dizio["mod_digit"]==1):
        tasto_2(k, x, y)
        dizio["cont_digit"]+=1
    
def tasto_1(k, x, y):
    """
    if k == ' ':
        #glutLayerGet(GLUT_NORMAL_DAMAGED)
        #glutLayerGet(GLUT_OVERLAY_DAMAGED)
        #glutDisplayFunc(None)
        fin_OGL = glutGetWindow()
        print fin_OGL
        print "Chiusura della finestra OpenGL"
        #glFinish()
        #glutShowWindow()
        glutHideWindow()
        #glutDestroyWindow(fin_OGL)
        #thread.exit()
        dizio_GL["Fin_att"] = 2
        print "hai premuto la barra spaziatrice"
        dizio_GL["larghe"] = 200
        dizio_GL["profon"] = 200
        dizio_GL["altez"] = 200
        print dizio_GL["larghe"]
        print dizio_GL["profon"]
        print dizio_GL["altez"]
        #sys.exit(0)
        #thread.exit_thread()
        #thread.exit()
        #avvio_()
        #init()
        #glLoadIdentity( )
        #glutPostRedisplay()
        #glutPostOverlayRedisplay()
    """
    if k =='b':
        dizio["descrizioni"]="glLoadIdentity()"
        glLoadIdentity()
        glutPostRedisplay()
    if k =='l':
        dizio["descrizioni"]="Legge i dati 3D in memoria RAM"
        lettura_dati_3D()
        dizio["num_tot_comp"]=len(list_comp)
        glutPostRedisplay()
    if k =='o':
        dizio["descrizioni"]="Aggiorna il disegno (?)"
        glLoadIdentity()
        glutPostRedisplay()
    if k =='a':
        dizio["descrizioni"]="Visualizza/Nasconde il gruppo di assi pricipale 1"
        if(dizio["stat_assi_1"]==1):
            dizio["stat_assi_1"]=0
        else:
            dizio["stat_assi_1"]=1
        glutPostRedisplay()
    if k =='f':
        dizio["descrizioni"]="Visualizza/Nasconde il gruppo di assi 2"
        if(dizio["stat_assi_2"]==1):
            dizio["stat_assi_2"]=0
        else:
            dizio["stat_assi_2"]=1
        glutPostRedisplay()
    if k =='g':
        dizio["descrizioni"]="Visualizza/Nasconde il gruppo di assi 3"
        if(dizio["stat_assi_3"]==1):
            dizio["stat_assi_3"]=0
        else:
            dizio["stat_assi_3"]=1
        glutPostRedisplay()
    if k =='d':
        if(dizio["stat_dim_glob"]==1):
            dizio["stat_dim_glob"]=0
        else:
            dizio["stat_dim_glob"]=1
        glutPostRedisplay()
    if k =='j':
        if(dizio["vis_num_ID"]==1):
            dizio["vis_num_ID"]=0
        else:
            dizio["vis_num_ID"]=1
        glutPostRedisplay()
    if k =='+':
        dizio["dim_ass"]+=0.1
        glutPostRedisplay()
    if k =='-':
        dizio["dim_ass"]-=0.1
        glutPostRedisplay()
    if k =='x':
        dizio["cono_prosp"]+=0.1
        #print dizio["cono_prosp"]
        glutPostRedisplay()
    if k =='z':
        dizio["cono_prosp"]-=0.1
        #print dizio["cono_prosp"]
        glutPostRedisplay()
    if k =='e':
        dizio["pos_scrite_X"]+=0.005
        glutPostRedisplay()
    if k =='q':
        dizio["pos_scrite_X"]-=0.005
        glutPostRedisplay()
    if k =='w':
        dizio["pos_scrite_Y"]+=0.005
        glutPostRedisplay()
    if k =='s':
        dizio["pos_scrite_Y"]-=0.005
        glutPostRedisplay()
    if k =='p':
        if(dizio["stat_prospetiva"]==1):
            dizio["stat_prospetiva"]=0
        else:
            dizio["stat_prospetiva"]=1
        glutPostRedisplay()
    if k =='m':
        if(dizio["stat_mouse"]==1):
            dizio["stat_mouse"]=0
        else:
            dizio["stat_mouse"]=1
        glutPostRedisplay()
    if k =='1':
        dizio["modalita"]=1
        glutPostRedisplay()
    if k =='2':
        dizio["modalita"]=2
        glutPostRedisplay()
    if k =='3':
        dizio["modalita"]=3
        glutPostRedisplay()
    if k =='5':
        dizio["modalita"]=5
        glutPostRedisplay()
    if k =='\t':
        dizio["pos_scrite_X"]=0
        dizio["pos_scrite_Y"]=0
        #dizio["comp_sell"]+=1
        #print dizio["comp_sell"]
        #if(dizio["comp_sell"]>=dizio["num_tot_comp"]):
        #    dizio["comp_sell"]=0
        glutPostRedisplay()
    if k =='\\':
        dizio["asse_sell"]+=1
        #print dizio["asse_sell"]
        if(dizio["asse_sell"]==3):
            dizio["asse_sell"]=0
        glutPostRedisplay()
    if k =='4':
        dizio["vinc_facc"]+=1
        if(dizio["vinc_facc"]==3):
            dizio["vinc_facc"]=0
        glutPostRedisplay()
    if k ==' ':
        dizio["grup_assi_sell"]+=1
        #print dizio["grup_assi_sell"]
        if(dizio["grup_assi_sell"]==3):
            dizio["grup_assi_sell"]=0
        glutPostRedisplay()
    if k =='i':
        #print "Scorri texture"
        try:
            #list_comp[dizio["comp_sell"]]["id_img_textu"]+=1
            #list_comp[dizio["comp_sell"]]["img_textu"]+=1
            #dizio["immag_sele"]+=1
            #list_comp[comp_num]["id_img_textu"]
            list_comp[dizio["comp_sell"]]["id_img_textu"]+=1
            if(list_comp[dizio["comp_sell"]]["id_img_textu"]>dizio["tot_num_textu"]):
                list_comp[dizio["comp_sell"]]["id_img_textu"]=0
            #LoadTextures()
            glutPostRedisplay()
        except:traceback.print_exc()
    if k =='0':
        dizio["descrizioni"]=" Aggiorna disegno leggendo i dati nel file salvato (*.POGL)"
        lettura_dati_3D_db()
        LoadTextures()
        glutPostRedisplay()
    if k =='9':
        scrittura_dati_3D_db()
        glutPostRedisplay()
    if k =='n':
        #aggiunge un componente
        nulla=None
        nuovo_comp()
        glutPostRedisplay()
    if k =='c':
        #aggiunge un componente
        nulla=None
        try:copia_comp()
        except:print "Non c' nessun oggetto da copiare"
        glutPostRedisplay()
    if k =='6':
        #descrizione
        nulla=None
        glutPostRedisplay()
    if k =='v':
        #Digita un valore
        nulla=None
        if(dizio["modalita"]==2 and dizio["asse_sell"]==0):
            valore=float(input("digita un valore:"))
            print valore
            list_comp[dizio["comp_sell"]]["pos_orig_x"]+=valore
        if(dizio["modalita"]==2 and dizio["asse_sell"]==1):
            valore=float(input("digita un valore:"))
            print valore
            list_comp[dizio["comp_sell"]]["pos_orig_y"]+=valore
        if(dizio["modalita"]==2 and dizio["asse_sell"]==2):
            valore=float(input("digita un valore:"))
            print valore
            list_comp[dizio["comp_sell"]]["pos_orig_z"]+=valore
        if(dizio["modalita"]==3 and dizio["asse_sell"]==0):
            valore=float(input("digita un valore:"))
            print valore
            list_comp[dizio["comp_sell"]]["dim_comp_L"]+=valore
        if(dizio["modalita"]==3 and dizio["asse_sell"]==1):
            valore=float(input("digita un valore:"))
            print valore
            list_comp[dizio["comp_sell"]]["dim_comp_H"]+=valore
        if(dizio["modalita"]==3 and dizio["asse_sell"]==2):
            valore=float(input("digita un valore:"))
            print valore
            list_comp[dizio["comp_sell"]]["dim_comp_P"]+=valore
        glutPostRedisplay()
    if k =='k':
        #Digita il numero di oggetto da selezionare
        nulla=None
        try:
            #valore=input("Digita il numero di oggetto da selezionare:")
            #dizio["comp_sell"]=valore
            #print valore
            dizio["mod_digit"]=1
            dizio["digitazioni"]=""
            dizio["cont_digit"]=0
        except:
            print "Il valore digitato non  valido"
        glutPostRedisplay()
    if (k =='z' and dizio["tasto_comb"]==2):
        print "if (k =='z' and dizio['tasto_comb']==2):"
        #Annulla le ultime modifiche
        nulla=None
        #li["tasto_comb"]==2
    if (k =='h'):
        #print "if (k =='h'):"
        webbrowser.open("Prodotto_OpenGL_2009_05_25_Guida.html",1)
        nulla=None
    if (k ==''):
        #print "Funzione avviata con tasto [canc]"
        #Cancella un componente selezionato
        #nulla=None
        canc_comp_sel()
        glutPostRedisplay()
    if (k =='b'):
        print "Sposta e modifica tramite la posizione di una faccia rispetto ad un'altra"
        dizio["descrizioni"]="Sposta e modifica tramite la posizione di una faccia rispetto ad un'altra"
        #nulla=None
        glutPostRedisplay()
    if (k =='t'):
        print "Collega oggetto selezionato a formula matematica"
        dizio["descrizioni"]="Collega oggetto selezionato a formula matematica"
##        #dizio_formule={}
        #nulla=None
        glutPostRedisplay()
        
def tasto_2(k, x, y):
    dizio["descrizioni"] = "Digita l'ID dell'oggetto da selezionare"
    if(dizio["cont_digit"] > 0):
        dizio["digitazioni"] += k
        if (k =='\n' or k =='\r'):
            try:
                dizio["comp_sell"]=int(dizio["digitazioni"])
            except:
                dizio["descrizioni"] = "l'ID inserito non  valido"
            #print "ritorno"
            dizio["mod_digit"]=0
            dizio["cont_digit"]=0
            dizio["digitazioni"]=""
    glutPostRedisplay()
        
def copia_comp():
    #aggiunge un componente
    print "Copia di un componente"
    #nulla=None
    dizio["nuov_comp"]+=1
    compon={}
    compon["Nom_est_prod"]="Componente senza nome_%s"%(dizio["nuov_comp"])
    compon["dim_comp_L"]= list_comp[dizio["comp_sell"]]["dim_comp_L"]
    compon["dim_comp_P"]= list_comp[dizio["comp_sell"]]["dim_comp_P"]
    compon["dim_comp_H"]= list_comp[dizio["comp_sell"]]["dim_comp_H"]
    compon["pos_orig_x"]= list_comp[dizio["comp_sell"]]["pos_orig_x"]
    compon["pos_orig_y"]= list_comp[dizio["comp_sell"]]["pos_orig_y"]
    compon["pos_orig_z"]= list_comp[dizio["comp_sell"]]["pos_orig_z"]
    compon["pos_orig_2_x"]= list_comp[dizio["comp_sell"]]["pos_orig_2_x"]
    compon["pos_orig_2_y"]= list_comp[dizio["comp_sell"]]["pos_orig_2_y"]
    compon["pos_orig_2_z"]= list_comp[dizio["comp_sell"]]["pos_orig_2_z"]
    compon["ang_orig_x"]= list_comp[dizio["comp_sell"]]["ang_orig_x"]
    compon["ang_orig_y"]= list_comp[dizio["comp_sell"]]["ang_orig_y"]
    compon["ang_orig_z"]= list_comp[dizio["comp_sell"]]["ang_orig_z"]
    #compon["ang_orig_z"]= list_comp[dizio["comp_sell"]]["immag_sele"]
    compon["id_img_textu"]=list_comp[dizio["comp_sell"]]["id_img_textu"]
    list_comp.append(compon)
    dizio["num_tot_comp"]=len(list_comp)
    global num_comp
    num_comp=dizio["num_tot_comp"]
    dizio["comp_sell"]=dizio["num_tot_comp"]-1
    #file_db = anydbm.open(dizio["file_dat_antep_3D_db"],"c")
    #file_db["nuov_comp"]=str(dizio["nuov_comp"])
    #file_db.close()
    glutPostRedisplay()
    #print list_comp

def nuovo_comp():
    #aggiunge un componente
    print "Aggiunta di un nuovo componente"
    #nulla=None
    dizio["nuov_comp"]+=1
    compon={}
    compon["Nom_est_prod"]="Componente senza nome_%s"%(dizio["nuov_comp"])
    compon["dim_comp_L"]= 100.0
    compon["dim_comp_P"]= 100.0
    compon["dim_comp_H"]= 100.0
    compon["pos_orig_x"]= 0.0
    compon["pos_orig_y"]= 0.0
    compon["pos_orig_z"]= 0.0
    compon["pos_orig_2_x"]= 0.0
    compon["pos_orig_2_y"]= 0.0
    compon["pos_orig_2_z"]= 0.0
    compon["ang_orig_x"]= 0.0
    compon["ang_orig_y"]= 0.0
    compon["ang_orig_z"]= 0.0
    #compon["ang_orig_z"]= list_comp[dizio["comp_sell"]]["immag_sele"]
    compon["id_img_textu"]=0
    list_comp.append(compon)
    dizio["num_tot_comp"]=len(list_comp)
    global num_comp
    num_comp=dizio["num_tot_comp"]
    dizio["comp_sell"]=dizio["num_tot_comp"]-1
    #file_db = anydbm.open(dizio["file_dat_antep_3D_db"],"c")
    #file_db["nuov_comp"]=str(dizio["nuov_comp"])
    #file_db.close()
    glutPostRedisplay()
    #print list_comp

def canc_comp_sel():
    try:
        #aggiunge un componente
        print "Cancellazione di un componente selezionato"
        nulla=None
        #for comp_num in range(num_comp):
        #    if(dizio["comp_sell"]==comp_num):
        del list_comp[dizio["comp_sell"]]
        dizio["num_tot_comp"]=len(list_comp)
        global num_comp
        num_comp=dizio["num_tot_comp"]
        file_db = anydbm.open(dizio["file_dat_antep_3D_db"],"c")
        file_db["nuov_comp"]=str(dizio["nuov_comp"])
        file_db.close()
        dizio["comp_sell"]=0
        glutPostRedisplay()
    except:
        nulla=None

def menu(s,x,y):
    glutCreateMenu(JoinStyle)
    glutAddMenuEntry("Exit",99)
    glutAttachMenu(GLUT_MIDDLE_BUTTON)
    #print "Stato men"
    #print s,x,y

def mouse_bot(b,s,x,y):
    #dizio["stat_GL_SELECT"]=1
    #glRenderMode(GL_SELECT) #entrara in selection mode
    #display()
    dizio["tasto_comb"] = glutGetModifiers()
    #print "Tasto_comb = %s"%(dizio["tasto_comb"])
    #print "Pressione bottoni mause"
    #print b,s,x,y
    dizio["bot_mou"] = b
    if(dizio["modalita"]==1 and dizio["bot_mou"]==0 and dizio["tasto_comb"]==0):
        #dizio["angolo_visual_X"]+=0
        #dizio["angolo_visual_Y"]+=0
        #glutPostRedisplay()
        if(y>dizio["y_me"]):
            dizio["angolo_visual_X"]+=0
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["angolo_visual_X"]-=0
            dizio["y_me"]=y
            glutPostRedisplay()
        if(x>dizio["x_me"]):
            dizio["angolo_visual_Y"]+=0
            dizio["x_me"]=x
            glutPostRedisplay()
        if(x<dizio["x_me"]):
            dizio["angolo_visual_Y"]-=0
            dizio["x_me"]=x
            glutPostRedisplay()
    if(dizio["modalita"]==1 and dizio["bot_mou"]==0 and dizio["tasto_comb"]==1):
        if(y>dizio["y_me"]):
            dizio["dist_osserv"]+=0
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["dist_osserv"]-=0
            dizio["y_me"]=y
            glutPostRedisplay()
    if(dizio["modalita"]==1 and dizio["bot_mou"]==1):
        if(y>dizio["y_me"]):
            dizio["dist_osserv"]+=0
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["dist_osserv"]-=0
            dizio["y_me"]=y
            glutPostRedisplay()
    if(dizio["modalita"]==1 and dizio["bot_mou"]==2):
        if(y>dizio["y_me"]):
            dizio["pos_visual_Y"]+=0
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["pos_visual_Y"]-=0
            dizio["y_me"]=y
            glutPostRedisplay()
        if(x>dizio["x_me"]):
            dizio["pos_visual_X"]+=0
            dizio["x_me"]=x
            glutPostRedisplay()
        if(x<dizio["x_me"]):
            dizio["pos_visual_X"]-=0
            dizio["x_me"]=x
            glutPostRedisplay()
    try:
        if(dizio["modalita"]==2 and dizio["bot_mou"]==0):
            nulla=None
            if(y>dizio["y_me"]):
                list_comp[dizio["comp_sell"]]["pos_orig_x"]+=0
                list_comp[dizio["comp_sell"]]["pos_orig_y"]+=0
                list_comp[dizio["comp_sell"]]["pos_orig_z"]+=0
                dizio["y_me"]=y
                glutPostRedisplay()
            if(y<dizio["y_me"]):
                list_comp[dizio["comp_sell"]]["pos_orig_x"]-=0
                list_comp[dizio["comp_sell"]]["pos_orig_y"]-=0
                list_comp[dizio["comp_sell"]]["pos_orig_z"]-=0
                dizio["y_me"]=y
                glutPostRedisplay()
        if(dizio["modalita"]==2 and dizio["bot_mou"]==2):
            nulla=None
            if(y>dizio["y_me"]):
                list_comp[dizio["comp_sell"]]["ang_orig_x"]+=0
                list_comp[dizio["comp_sell"]]["ang_orig_y"]+=0
                list_comp[dizio["comp_sell"]]["ang_orig_z"]+=0
                dizio["y_me"]=y
                glutPostRedisplay()
            if(y<dizio["y_me"]):
                list_comp[dizio["comp_sell"]]["ang_orig_x"]-=0
                list_comp[dizio["comp_sell"]]["ang_orig_y"]-=0
                list_comp[dizio["comp_sell"]]["ang_orig_z"]-=0
                dizio["y_me"]=y
                glutPostRedisplay()
            glutPostRedisplay()
        if(dizio["modalita"]==3 and dizio["bot_mou"]==0):
            nulla=None
            if(y>dizio["y_me"]):
                list_comp[dizio["comp_sell"]]["dim_comp_L"]+=0
                list_comp[dizio["comp_sell"]]["dim_comp_H"]+=0
                list_comp[dizio["comp_sell"]]["dim_comp_P"]+=0
                dizio["y_me"]=y
                glutPostRedisplay()
            if(y<dizio["y_me"]):
                list_comp[dizio["comp_sell"]]["dim_comp_L"]-=0
                list_comp[dizio["comp_sell"]]["dim_comp_H"]-=0
                list_comp[dizio["comp_sell"]]["dim_comp_P"]-=0
                dizio["y_me"]=y
                glutPostRedisplay()
        if(dizio["modalita"]==5 and dizio["bot_mou"]==0):
            dizio["stat_GL_SELECT"]=1
            glutPostRedisplay()
    except:
        nulla=None
        traceback.print_exc()
    if(dizio["modalita"]==5 and dizio["bot_mou"]==0 and dizio["tasto_comb"]==0):
        #dizio["angolo_visual_X"]+=0
        #dizio["angolo_visual_Y"]+=0
        #glutPostRedisplay()
        if(y>dizio["y_me"]):
            dizio["angolo_visual_X"]+=0
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["angolo_visual_X"]-=0
            dizio["y_me"]=y
            glutPostRedisplay()
        if(x>dizio["x_me"]):
            dizio["angolo_visual_Y"]+=0
            dizio["x_me"]=x
            glutPostRedisplay()
        if(x<dizio["x_me"]):
            dizio["angolo_visual_Y"]-=0
            dizio["x_me"]=x
            glutPostRedisplay()

def mov_mouse_prem(x,y):
    #dizio["descrizioni"] = ""
    #print "Movimento mause bottoni premuti"
    #print x,y
    #print dizio["bot_mou"]
    if(dizio["modalita"]==1 and dizio["bot_mou"]==0 and dizio["tasto_comb"]==0):
        if(y>dizio["y_me"]):
            dizio["angolo_visual_X"]+=y-dizio["y_me"]
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["angolo_visual_X"]-=dizio["y_me"]-y
            dizio["y_me"]=y
            glutPostRedisplay()
        if(x>dizio["x_me"]):
            dizio["angolo_visual_Y"]+=x-dizio["x_me"]
            dizio["x_me"]=x
            glutPostRedisplay()
        if(x<dizio["x_me"]):
            dizio["angolo_visual_Y"]-=dizio["x_me"]-x
            dizio["x_me"]=x
            glutPostRedisplay()
    if(dizio["modalita"]==1 and dizio["bot_mou"]==0 and dizio["tasto_comb"]==1):
        if(y>dizio["y_me"]):
            dizio["dist_osserv"]+=float(y-dizio["y_me"])/100
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["dist_osserv"]-=float(dizio["y_me"]-y)/100
            dizio["y_me"]=y
            glutPostRedisplay()
    if(dizio["modalita"]==1 and dizio["bot_mou"]==1):
        if(y>dizio["y_me"]):
            dizio["dist_osserv"]+=float(y-dizio["y_me"])/100
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["dist_osserv"]-=float(dizio["y_me"]-y)/100
            dizio["y_me"]=y
            glutPostRedisplay()
    if(dizio["modalita"]==1 and dizio["bot_mou"]==2):
        if(y>dizio["y_me"]):
            dizio["pos_visual_Y"]-=float(y-dizio["y_me"])/100
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["pos_visual_Y"]+=float(dizio["y_me"]-y)/100
            dizio["y_me"]=y
            glutPostRedisplay()
        if(x>dizio["x_me"]):
            dizio["pos_visual_X"]+=float(x-dizio["x_me"])/100
            dizio["x_me"]=x
            glutPostRedisplay()
        if(x<dizio["x_me"]):
            dizio["pos_visual_X"]-=float(dizio["x_me"]-x)/100
            dizio["x_me"]=x
            glutPostRedisplay()
    if(dizio["modalita"]==1 and dizio["bot_mou"]==2):
        nulla=None
    try:
        if(dizio["modalita"]==2 and dizio["bot_mou"]==0 and dizio["tasto_comb"]==1):
            nulla=None
            #dizio["grup_assi_sell"]==0
            if(dizio["asse_sell"]==0):
                if(y>dizio["y_me"]):
                    #list_comp[dizio["comp_sell"]]["pos_orig_x"]+=0.01
                    list_comp[dizio["comp_sell"]]["pos_orig_x"]+=float(y-dizio["y_me"])/100
                    dizio["y_me"]=y
                    glutPostRedisplay()
                if(y<dizio["y_me"]):
                    #list_comp[dizio["comp_sell"]]["pos_orig_x"]-=0.01
                    list_comp[dizio["comp_sell"]]["pos_orig_x"]-=float(dizio["y_me"]-y)/100
                    dizio["y_me"]=y
                    glutPostRedisplay()
            if(dizio["asse_sell"]==1):
                if(y>dizio["y_me"]):
                    #list_comp[dizio["comp_sell"]]["pos_orig_x"]+=0.01
                    list_comp[dizio["comp_sell"]]["pos_orig_y"]-=float(y-dizio["y_me"])/100
                    dizio["y_me"]=y
                    glutPostRedisplay()
                if(y<dizio["y_me"]):
                    #list_comp[dizio["comp_sell"]]["pos_orig_x"]-=0.01
                    list_comp[dizio["comp_sell"]]["pos_orig_y"]+=float(dizio["y_me"]-y)/100
                    dizio["y_me"]=y
                    glutPostRedisplay()
            if(dizio["asse_sell"]==2):
                if(y>dizio["y_me"]):
                    #list_comp[dizio["comp_sell"]]["pos_orig_x"]+=0.01
                    list_comp[dizio["comp_sell"]]["pos_orig_z"]+=float(y-dizio["y_me"])/100
                    dizio["y_me"]=y
                    glutPostRedisplay()
                if(y<dizio["y_me"]):
                    #list_comp[dizio["comp_sell"]]["pos_orig_x"]-=0.01
                    list_comp[dizio["comp_sell"]]["pos_orig_z"]-=float(dizio["y_me"]-y)/100
                    dizio["y_me"]=y
                    glutPostRedisplay()
            #glTranslatef(list_comp[comp_num]["pos_orig_x"],list_comp[comp_num]["pos_orig_y"],list_comp[comp_num]["pos_orig_z"])
            #glRotatef(list_comp[comp_num]["ang_orig_x"],1.0,0.0,0.0)
            #glRotatef(list_comp[comp_num]["ang_orig_y"],0.0,1.0,0.0)
            #glRotatef(list_comp[comp_num]["ang_orig_z"],0.0,0.0,1.0)
        if(dizio["modalita"]==2 and dizio["bot_mou"]==2 and dizio["tasto_comb"]==1):
            nulla=None
            if(dizio["asse_sell"]==0):
                if(y>dizio["y_me"]):
                    list_comp[dizio["comp_sell"]]["ang_orig_x"]+=y-dizio["y_me"]
                    dizio["y_me"]=y
                    glutPostRedisplay()
                if(y<dizio["y_me"]):
                    list_comp[dizio["comp_sell"]]["ang_orig_x"]-=dizio["y_me"]-y
                    dizio["y_me"]=y
                    glutPostRedisplay()
            if(dizio["asse_sell"]==1):
                if(y>dizio["y_me"]):
                    list_comp[dizio["comp_sell"]]["ang_orig_y"]+=y-dizio["y_me"]
                    dizio["y_me"]=y
                    glutPostRedisplay()
                if(y<dizio["y_me"]):
                    list_comp[dizio["comp_sell"]]["ang_orig_y"]-=dizio["y_me"]-y
                    dizio["y_me"]=y
                    glutPostRedisplay()
            if(dizio["asse_sell"]==2):
                if(y>dizio["y_me"]):
                    list_comp[dizio["comp_sell"]]["ang_orig_z"]+=y-dizio["y_me"]
                    dizio["y_me"]=y
                    glutPostRedisplay()
                if(y<dizio["y_me"]):
                    list_comp[dizio["comp_sell"]]["ang_orig_z"]-=dizio["y_me"]-y
                    dizio["y_me"]=y
                    glutPostRedisplay()
        if(dizio["modalita"]==3 and dizio["bot_mou"]==0 and dizio["tasto_comb"]==1):
            nulla=None
            #dizio["grup_assi_sell"]==0
            if(dizio["asse_sell"]==0):
                if(y>dizio["y_me"]):
                    increm=float(y-dizio["y_me"])
                    list_comp[dizio["comp_sell"]]["dim_comp_L"]+=increm
                    if(dizio["vinc_facc"]==1):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_x"]+=(increm/100)/2
                    if(dizio["vinc_facc"]==2):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_x"]+=-(increm/100)/2
                    dizio["y_me"]=y
                    glutPostRedisplay()
                if(y<dizio["y_me"]):
                    increm=float(dizio["y_me"]-y)
                    list_comp[dizio["comp_sell"]]["dim_comp_L"]-=increm
                    if(dizio["vinc_facc"]==1):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_x"]-=(increm/100)/2
                    if(dizio["vinc_facc"]==2):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_x"]-=-(increm/100)/2
                    dizio["y_me"]=y
                    glutPostRedisplay()
            if(dizio["asse_sell"]==1):
                if(y>dizio["y_me"]):
                    increm=float(y-dizio["y_me"])
                    list_comp[dizio["comp_sell"]]["dim_comp_H"]+=increm
                    if(dizio["vinc_facc"]==1):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_y"]+=(increm/100)/2
                    if(dizio["vinc_facc"]==2):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_y"]+=-(increm/100)/2
                    dizio["y_me"]=y
                    glutPostRedisplay()
                if(y<dizio["y_me"]):
                    increm=float(dizio["y_me"]-y)
                    list_comp[dizio["comp_sell"]]["dim_comp_H"]-=increm
                    if(dizio["vinc_facc"]==1):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_y"]-=(increm/100)/2
                    if(dizio["vinc_facc"]==2):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_y"]-=-(increm/100)/2
                    dizio["y_me"]=y
                    glutPostRedisplay()
            if(dizio["asse_sell"]==2):
                if(y>dizio["y_me"]):
                    increm=float(y-dizio["y_me"])
                    list_comp[dizio["comp_sell"]]["dim_comp_P"]+=increm
                    if(dizio["vinc_facc"]==1):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_z"]+=(increm/100)/2
                    if(dizio["vinc_facc"]==2):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_z"]+=-(increm/100)/2
                    dizio["y_me"]=y
                    glutPostRedisplay()
                if(y<dizio["y_me"]):
                    increm=float(dizio["y_me"]-y)
                    list_comp[dizio["comp_sell"]]["dim_comp_P"]-=increm
                    if(dizio["vinc_facc"]==1):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_z"]-=(increm/100)/2
                    if(dizio["vinc_facc"]==2):
                        list_comp[dizio["comp_sell"]]["pos_orig_2_z"]-=-(increm/100)/2
                    dizio["y_me"]=y
                    glutPostRedisplay()
            #glTranslatef(list_comp[comp_num]["pos_orig_x"],list_comp[comp_num]["pos_orig_y"],list_comp[comp_num]["pos_orig_z"])
            #glRotatef(list_comp[comp_num]["ang_orig_x"],1.0,0.0,0.0)
            #glRotatef(list_comp[comp_num]["ang_orig_y"],0.0,1.0,0.0)
            #glRotatef(list_comp[comp_num]["ang_orig_z"],0.0,0.0,1.0)
    except:
        nulla=None

def mov_mouse_prem_2(x,y):
    #print "Movimento mause bottoni premuti"
    #print x,y
    #print dizio["bot_mou"]
    if(dizio["modalita"]==1 and dizio["bot_mou"]==0):
        if(y>dizio["y_me"]):
            fat_x = dizio["angolo_visual_Y"]/90
            fat_y = dizio["angolo_visual_Y"]/90
            fat_z = dizio["angolo_visual_Y"]/90
            dizio["angolo_visual_X"]+=(y-dizio["y_me"])*fat_x
            dizio["angolo_visual_Y"]+=(y-dizio["y_me"])*fat_y
            dizio["angolo_visual_Z"]+=(y-dizio["y_me"])*fat_z
            dizio["y_me"]=y
            glutPostRedisplay()
        if(y<dizio["y_me"]):
            dizio["angolo_visual_X"]+=(y-dizio["y_me"])*fat_x
            dizio["angolo_visual_Y"]+=(y-dizio["y_me"])*fat_y
            dizio["angolo_visual_Z"]+=(y-dizio["y_me"])*fat_z
            dizio["y_me"]=y
            glutPostRedisplay()
        if(x>dizio["x_me"]):
            dizio["angolo_visual_X"]+=(x-dizio["x_me"])*fat_x
            dizio["angolo_visual_Y"]+=(x-dizio["x_me"])*fat_y
            dizio["angolo_visual_Z"]+=(x-dizio["x_me"])*fat_z
            dizio["x_me"]=x
            glutPostRedisplay()
        if(x<dizio["x_me"]):
            dizio["angolo_visual_X"]+=(x-dizio["x_me"])*fat_x
            dizio["angolo_visual_Y"]+=(x-dizio["x_me"])*fat_y
            dizio["angolo_visual_Z"]+=(x-dizio["x_me"])*fat_z
            dizio["x_me"]=x
            glutPostRedisplay()

def continua():
    nulla=None
    dizio["tasto_comb"] = glutGetModifiers()
    #print "Tasto_comb = %s"%(dizio["tasto_comb"])
    #glutPostRedisplay()

def mov_mouse(x,y):
    #print "Movimento mause"
    #print x,y
    dizio["x_me"]=x
    dizio["y_me"]=y
    glutPostRedisplay()
    
def stat_menu(s,x,y):
    print "Stato men"
    print s,x,y

def calc_prez(comp_num):
    #print "calc_prez()"
    #print list_comp[dizio["comp_sell"]]["dim_comp_L"]
    #list_comp[dizio["comp_sell"]]["dim_comp_P"]
    #print list_comp[dizio["comp_sell"]]["dim_comp_H"]
    #tot_prez = 100.00
    #prez_mq = 200.00
    #print dizio["prez_mq"]
    prez_ogg = (float(list_comp[comp_num]["dim_comp_L"])/100)*(float(list_comp[comp_num]["dim_comp_H"])/100)*dizio["prez_mq"]
    list_comp[comp_num]["prezzo"]=prez_ogg
    return prez_ogg

def stamp__dettagl_prez():
    print "Creazione file HTML con dettaglio dei prezzi"
    file_dettagl_prez=open("Dettaglio prezzi.html","w+t")
    for comp_num in range(num_comp):
        a=list_comp[comp_num]["Nom_est_prod"]
        b=list_comp[comp_num]["dim_comp_L"]
        c=list_comp[comp_num]["dim_comp_H"]
        #d=list_comp[comp_num]["prez_mq"]
        d=dizio["prez_mq"]
        e=list_comp[comp_num]["prezzo"]
        file_dettagl_prez.write("%s = (%sL*%sH)*%s . = %s .<br>"%(a,b,c,d,e))
    file_dettagl_prez.write("<br><br>Totale . = %s"%(dizio["tot_prez"]))
    file_dettagl_prez.close()
    webbrowser.open("Dettaglio prezzi.html",1)

def rinomina_elem():
    print "Rinomina elemento: %s"%(list_comp[dizio["comp_sell"]]["Nom_est_prod"])
    nome_nuov=raw_input("Digita il nuovo Nome dell'oggetto:")
    list_comp[dizio["comp_sell"]]["Nom_est_prod"]=nome_nuov

def avvio_():
    global lista_perc_textu
    print 'def avvio_():'
    lista_modif=[]
    dizio["color_sfond"]=0
    dizio["stat_assi_1"]=1
    dizio["stat_assi_2"]=1
    dizio["stat_assi_3"]=1
    dizio["stat_dim_glob"]=1
    dizio["vis_num_ID"]=1
    dizio["dim_ass"]=1
    dizio["cono_prosp"]=60
    #dizio["pos_scrite_X"]=-2
    #dizio["pos_scrite_Y"]=2
    dizio["pos_scrite_X"]=0
    dizio["pos_scrite_Y"]=0
    dizio["stat_prospetiva"]=1
    dizio["stat_mouse"]=1
    dizio["angolo_visual_X"]=0
    dizio["x_me"]=0
    dizio["angolo_visual_Y"]=0
    dizio["y_me"]=0
    dizio["dist_osserv"]=-4
    dizio["pos_visual_X"]=0
    dizio["pos_visual_Y"]=0
    #lettura_dati_3D()
    #dizio["num_tot_comp"]=len(list_comp)
    dizio["stat_spost_iniz"]=1
    dizio["modalita"]=1
    dizio["bot_mou"]=0
    dizio["comp_sell"]=0
    #dizio["comp_sell"]=[]
    #dizio["comp_sell"].append(0)
    dizio["asse_sell"]=0
    dizio["grup_assi_sell"]=0
    #list_comp[dizio["comp_sell"]]["img_textu"]=0
    #dizio["immag_sele"]=0
    dizio["nuov_comp"]=0
    dizio["unit_mis"]="m"
    dizio["val_unit_mis"]=1
    dizio["vinc_facc"]=1
    dizio["stat_GL_SELECT"]=0
    dizio["prez_mq"]=200.0
    dizio["tasto_comb"]=0
    dizio["att_costr_3D_2"]=1
    dizio["att_costr_3D_linee"]=1
    dizio["descrizioni"]=""
    dizio["digitazioni"]=""
    dizio["mod_digit"]=0
    dizio["cont_digit"]=0
    lista_perc_textu = []
    lettura_dati_3D_db()
    print 'dizio["stat_spost_iniz"]=1'
    print "Eseguito il thread dell'anteprima OpenGL"
    print "Luminosit = %s"%(dizio_GL["lumin"])
    print "Larghezza = %s"%(dizio_GL["larghe"])
    print "Profondit = %s"%(dizio_GL["profon"])
    print "Altezza = %s"%(dizio_GL["altez"])
    glutInit(sys.argv)
    print "OpenGL punto 1"
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH )
    print "OpenGL punto 2"
    try:
        glutInitWindowSize(dizio["larg_fin"],dizio["alt_fin"])
        print "OpenGL punto 3"
        glutInitWindowPosition(0,0)
        print "OpenGL punto 4"
        #test=dizio["test_errore"]
        glutCreateWindow(sys.argv[0])
    except:
        print "Si  verificato un errore"
        glutInitWindowSize(640,480)
        print "OpenGL punto 3"
        glutInitWindowPosition(0,0)
        print "OpenGL punto 4"
        glutCreateWindow(sys.argv[0])
    print "OpenGL punto 5"
    init(  )
    #mouseInteractor.registerCallbacks( )
    print "OpenGL punto 6"
    glutDisplayFunc(display)
    #glutOverlayDisplayFunc(display)
    print "OpenGL punto 7"
    glutReshapeFunc(reshape)
    print "OpenGL punto 8"
    glutKeyboardFunc(tasto)
    glutSpecialFunc(tasto_special)
    #glutGetModifiers()
    print "OpenGL punto 9"
    #glutFullScreen()
    glutMotionFunc(mov_mouse_prem)
    print "OpenGL punto 10"
    #glutPassiveMotionFunc(mov_mouse)
    glutMouseFunc(mouse_bot)
    print "OpenGL punto 11"
    #glutIdleFunc(continua)
    #glutMenuStatusFunc(menu_compa)
    global esec_OGL
    print "OpenGL punto 12"
    print
    print "Premi il tasto [h] sulla finestra OpenGL per visualizzare la guida"
    glutMainLoop()

def apri_file_3D_db():
    file_3D_db = tkFileDialog.askopenfilename(filetypes=[("Archivio prodotti","*.POGL")])
    print "File aperto: %s"%(file_3D_db)
    if(file_3D_db!=""):
        dizio["file_dat_antep_3D_db"]=file_3D_db
        imp_Prod_OGL = anydbm.open("Impostazioni_di_Prodotto_OpenGL","c")
        imp_Prod_OGL["file_dat_antep_3D_db"]=file_3D_db
        imp_Prod_OGL.close()
        lettura_dati_3D_db()
        LoadTextures()
        glutReshapeWindow(dizio["larg_fin"],dizio["alt_fin"])
        glutSetWindowTitle("%s    (Su Misura 3D OpenGL TEST - www.strutture-forme-colori-movimenti.net)"%(file_3D_db))

def salva_c_n_file_3D_db():
    file_3D_db = tkFileDialog.asksaveasfilename(filetypes=[("Archivio prodotti","*.POGL")])
    print "File aperto: %s"%(file_3D_db)
    if(file_3D_db!=""):
        dizio["file_dat_antep_3D_db"]=file_3D_db
        imp_Prod_OGL = anydbm.open("Impostazioni_di_Prodotto_OpenGL","c")
        imp_Prod_OGL["file_dat_antep_3D_db"]=file_3D_db
        imp_Prod_OGL.close()
        scrittura_dati_3D_db()
        glutSetWindowTitle("%s    (Su Misura 3D OpenGL TEST - www.strutture-forme-colori-movimenti.net)"%(file_3D_db))

def lettura_dati_3D_db():
    global num_comp,list_comp,lista_perc_textu
    print "def lettura_dati_3D_db_2():"
    nulla=None
    try:
        verifica = dizio["file_dat_antep_3D_db"]
    except:
        print "lettura_dati_3D_db():except: punto 1"
        try:
            imp_Prod_OGL = anydbm.open("Impostazioni_di_Prodotto_OpenGL","r")
            dizio["file_dat_antep_3D_db"]=imp_Prod_OGL["file_dat_antep_3D_db"]
            dizio["prez_mq"]=float(imp_Prod_OGL["prez_mq"])
            imp_Prod_OGL.close()
        except:
            print "lettura_dati_3D_db():except: punto 2"
            print "File non trovato, aprire o salvare un nuovo file 3D"
    try:
        print dizio["file_dat_antep_3D_db"]
        file_db = anydbm.open(dizio["file_dat_antep_3D_db"],"r")
        dizio["num_tot_comp"]=int(file_db["num_tot_comp"])
        num_comp=int(file_db["num_tot_comp"])
        list_comp =[]
        lista_perc_textu = []
        try:
            dizio["tot_num_textu"] = int(file_db["tot_num_textu"])
            for num_textu in range(dizio["tot_num_textu"]):
                lista_perc_textu.append(file_db["lista_perc_textu,%s"%(num_textu)])
        except:
            print "lettura_dati_3D_db():except: punto 3"
            print "Errore in: lista_perc_textu.append(file_db['lista_perc_textu,%s'%(num_textu)])"
            dizio["tot_num_textu"] = 1
            lista_perc_textu.append("Textur predefinita.jpg")
        for comp_num in range(dizio["num_tot_comp"]):
            compon={}
            try:
                str_list_prop=file_db["lista_propr,%s"%(comp_num)]
            except:
                print "lettura_dati_3D_db():except: punto 4"
                #nulla=None
                str_list_prop="Nom_est_prod,dim_comp_L,dim_comp_P,dim_comp_H,pos_orig_x,pos_orig_y,pos_orig_z,pos_orig_2_x,pos_orig_2_y,pos_orig_2_z,\
ang_orig_x,ang_orig_y,ang_orig_z,id_img_textu,"
            num_prop=str_list_prop.count(",")
            compon["lista_propr"]=[]
            for c in range(num_prop):
                compon["lista_propr"].append(str_list_prop.split(",")[c])
            try:
                compon["tipi_dati"]=[]
                for propr in compon["lista_propr"]:
                    tipo_dato=file_db["%s,%s,tipo_dato"%(propr,comp_num)]
                    compon["tipi_dati"].append(tipo_dato)
                    if (tipo_dato=="str"):
                        try:compon[propr]=file_db["%s,%s"%(propr,comp_num)]
                        except:compon[propr]=None
                    if (tipo_dato=="int"):
                        try:compon[propr]=int(file_db["%s,%s"%(propr,comp_num)])
                        except:compon[propr]=0
                    if (tipo_dato=="float"):
                        try:compon[propr]=float(file_db["%s,%s"%(propr,comp_num)])
                        except:compon[propr]=0.0
            except:
                print "lettura_dati_3D_db():except: punto 5"
                compon["tipi_dati"]=[]
                #traceback.print_exc()
                #compon[propr]=None
                lista_tipi_dati=["str","float","float","float","float","float","float","float","float","float","float","float","float","int"]
                compon["tipi_dati"]=lista_tipi_dati
                n_propr =0
                for propr in compon["lista_propr"]:
                    #compon["tipo_dato"]=lista_tipi_dati[n_propr]
                    if (lista_tipi_dati[n_propr]=="str"):
                        try:compon[propr]=file_db["%s,%s"%(propr,comp_num)]
                        except:compon[propr]=None
                    if (lista_tipi_dati[n_propr]=="int"):
                        try:compon[propr]=int(file_db["%s,%s"%(propr,comp_num)])
                        except:compon[propr]=0
                    if (lista_tipi_dati[n_propr]=="float"):
                        try:compon[propr]=float(file_db["%s,%s"%(propr,comp_num)])
                        except:compon[propr]=0.0
                    n_propr+=1
            list_comp.append(compon)
        dizio["lista_propr_gen"]=[]
        try:
            str_list_prop_gen=file_db["lista_propr_gen"]
        except:
            print "lettura_dati_3D_db():except: punto 6"
            str_list_prop_gen="angolo_visual_X,angolo_visual_Y,dist_osserv,pos_visual_X,pos_visual_Y,nuov_comp,prez_mq,larg_fin,alt_fin,"
        num_prop_gen=str_list_prop_gen.count(",")
        for c in range(num_prop_gen):
            dizio["lista_propr_gen"].append(str_list_prop_gen.split(",")[c])
        try:
            dizio["tipi_dati_gen"]=[]
            for propr_gen in dizio["lista_propr_gen"]:
                tipo_dato=file_db["%s,tipo_dato"%(propr_gen)]
                dizio["tipi_dati_gen"].append(tipo_dato)
                if (tipo_dato=="str"):
                    try:dizio[propr_gen]=file_db[propr_gen]
                    except:dizio[propr_gen]=None
                if (tipo_dato=="int"):
                    try:dizio[propr_gen]=int(file_db[propr_gen])
                    except:dizio[propr_gen]=0
                if (tipo_dato=="float"):
                    try:dizio[propr_gen]=float(file_db[propr_gen])
                    except:dizio[propr_gen]=0.0
        except:
            print "lettura_dati_3D_db():except: punto 7"
            dizio["tipi_dati_gen"]=[]
            lista_tipi_dati_gen=["float","float","float","float","float","int","float","int","int"]
            dizio["tipi_dati_gen"]=lista_tipi_dati_gen
            n_propr_gen =0
            for propr_gen in dizio["lista_propr_gen"]:
                if (lista_tipi_dati_gen[n_propr_gen]=="str"):
                    try:dizio[propr_gen]=file_db[propr_gen]
                    except:dizio[propr_gen]=None
                if (lista_tipi_dati_gen[n_propr_gen]=="int"):
                    try:dizio[propr_gen]=int(file_db[propr_gen])
                    except:dizio[propr_gen]=0
                if (lista_tipi_dati_gen[n_propr_gen]=="float"):
                    try:dizio[propr_gen]=float(file_db[propr_gen])
                    except:dizio[propr_gen]=0.0
                n_propr_gen+=1
        """try:
            dizio["prez_mq"]=float(file_db["prez_mq"])
        except:
            dizio["prez_mq"]=200.0
        try:
            dizio["larg_fin"]=int(file_db["larg_fin"])
            dizio["alt_fin"]=int(file_db["alt_fin"])
        except:
            nulla=None"""
        file_db.close()
    except:
        print "lettura_dati_3D_db():except: punto 8"
        print "Errore di lettura db"
        traceback.print_exc()
        dizio["num_tot_comp"]=0
        list_comp =[]
        compon={}
        num_comp=0

def lettura_dati_3D_db_2():
    global num_comp,list_comp,lista_perc_textu
    print "lettura_dati_3D_db()"
    nulla=None
    try:
        verifica = dizio["file_dat_antep_3D_db"]
    except:
        try:
            imp_Prod_OGL = anydbm.open("Impostazioni_di_Prodotto_OpenGL","r")
            dizio["file_dat_antep_3D_db"]=imp_Prod_OGL["file_dat_antep_3D_db"]
            dizio["prez_mq"]=float(imp_Prod_OGL["prez_mq"])
            imp_Prod_OGL.close()
        except:
            print "File non trovato, aprire o salvare un nuovo file 3D"
    try:
        print dizio["file_dat_antep_3D_db"]
        file_db = anydbm.open(dizio["file_dat_antep_3D_db"],"r")
        dizio["num_tot_comp"]=int(file_db["num_tot_comp"])
        #global num_comp,list_comp
        num_comp=int(file_db["num_tot_comp"])
        #print dizio["num_tot_comp"]
        #print num_comp
        #print list_comp
        list_comp =[]
        #print list_comp
        lista_perc_textu = []
        try:
            dizio["tot_num_textu"] = int(file_db["tot_num_textu"])
            for num_textu in range(dizio["tot_num_textu"]):
                lista_perc_textu.append(file_db["lista_perc_textu,%s"%(num_textu)])
        except:
            print "Errore in: lista_perc_textu.append(file_db['lista_perc_textu,%s'%(num_textu)])"
            dizio["tot_num_textu"] = 1
            lista_perc_textu.append("Textur predefinita.jpg")
        for comp_num in range(dizio["num_tot_comp"]):
            compon={}
            #try:compon["Ditta"]=float(file_db["Ditta,%s"%(comp_num)])
            #except:compon["Ditta"]=None
            #try:compon["num_sot_grup_prod"]=float(file_db["num_sot_grup_prod,%s"%(comp_num)])
            #except:compon["num_sot_grup_prod"]=1
            #for a in range(compon["num_sot_grup_prod"]):
            #    try:compon[a]["sot_grup_prod"]=float(file_db["sot_grup_prod,%s,%s"%(comp_num,a)])
            #    except:compon[a]["sot_grup_prod"]=None
            try:compon["Nom_est_prod"]=file_db["Nom_est_prod,%s"%(comp_num)]
            except:compon["Nom_est_prod"]=None
            #print compon["Nom_est_prod"]
            try:compon["dim_comp_L"]=float(file_db["dim_comp_L,%s"%(comp_num)])
            except:compon["dim_comp_L"]=0
            try:compon["dim_comp_P"]=float(file_db["dim_comp_P,%s"%(comp_num)])
            except:compon["dim_comp_P"]=0
            try:compon["dim_comp_H"]=float(file_db["dim_comp_H,%s"%(comp_num)])
            except:compon["dim_comp_H"]=0
            try:compon["pos_orig_x"]=float(file_db["pos_orig_x,%s"%(comp_num)])
            except:compon["pos_orig_x"]=0
            try:compon["pos_orig_y"]=float(file_db["pos_orig_y,%s"%(comp_num)])
            except:compon["pos_orig_y"]=0
            try:compon["pos_orig_z"]=float(file_db["pos_orig_z,%s"%(comp_num)])
            except:compon["pos_orig_z"]=0
            try:compon["pos_orig_2_x"]=float(file_db["pos_orig_2_x,%s"%(comp_num)])
            except:compon["pos_orig_2_x"]=0
            try:compon["pos_orig_2_y"]=float(file_db["pos_orig_2_y,%s"%(comp_num)])
            except:compon["pos_orig_2_y"]=0
            try:compon["pos_orig_2_z"]=float(file_db["pos_orig_2_z,%s"%(comp_num)])
            except:compon["pos_orig_2_z"]=0
            try:compon["ang_orig_x"]=float(file_db["ang_orig_x,%s"%(comp_num)])
            except:compon["ang_orig_x"]=0
            try:compon["ang_orig_y"]=float(file_db["ang_orig_y,%s"%(comp_num)])
            except:compon["ang_orig_y"]=0
            try:compon["ang_orig_z"]=float(file_db["ang_orig_z,%s"%(comp_num)])
            except:compon["ang_orig_z"]=0
            try:compon["id_img_textu"]=int(file_db["id_img_textu,%s"%(comp_num)])
            except:compon["id_img_textu"]=0
            #lista_perc_textu.append(perc_nuov_img_textu)
            #list_comp[comp_num][lista_perc_textu["id_img_textu"]]
            #file_db["perc_img_textu,%s"%(comp_num)]=str(list_comp[comp_num][lista_perc_textu["id_img_textu"]])
            #lista_perc_textu.append(file_db["perc_img_textu,%s"%(comp_num)])
            #try:compon["perc_img_textu"]=lista_perc_textu["id_img_textu"]
            #except:compon["perc_img_textu"]="Textur predefinita.jpg"
            #try:compon["perc_img_textu"]=float(file_db["perc_img_textu,%s"%(comp_num)])
            #except:compon["img_textu"]=0
            #list_comp[dizio["comp_sell"]]["img_textu"]
            #try:compon["unit_mis"]=float(file_db["unit_mis,%s"%(comp_num)])
            #except:compon["unit_mis"]=0
            #try:compon["prez_unit_mis"]=float(file_db["prez_unit_mis,%s"%(comp_num)])
            #except:compon["prez_unit_mis"]=0
            #try:compon["ID_formula_prezzo"]=float(file_db["ID_formula_prezzo,%s"%(comp_num)])
            #except:compon["ID_formula_prezzo"]=0
            #try:compon["Kg_unit_mis"]=float(file_db["Kg_unit_mis,%s"%(comp_num)])
            #except:compon["Kg_unit_mis"]=0
            #try:compon["num_lavor_agg"]=float(file_db["num_lavor_agg,%s"%(comp_num)])
            #except:compon["num_lavor_agg"]=0
            #for b in range(compon["num_lavor_agg"]):
            #    try:compon["lavor_agg"]=float(file_db["lavor_agg,%s"%(comp_num)])
            #    except:compon["lavor_agg"]=0
            #    try:compon["temp_lav_unit_mis"]=float(file_db["temp_lav_unit_mis,%s"%(comp_num)])
            #    except:compon["temp_lav_unit_mis"]=0
            #try:compon["temp_unit_mis"]=float(file_db["temp_unit_mis,%s"%(comp_num)])
            #except:compon["temp_unit_mis"]=0
            list_comp.append(compon)
            #print list_comp
        #print
        #print list_comp
        #list_comp[dizio["comp_sell"]]["img_textu"]
        #dizio["immag_sele"]=int(file_db["immag_sele"])
        dizio["angolo_visual_X"]=float(file_db["angolo_visual_X"])
        dizio["angolo_visual_Y"]=float(file_db["angolo_visual_Y"])
        dizio["dist_osserv"]=float(file_db["dist_osserv"])
        dizio["pos_visual_X"]=float(file_db["pos_visual_X"])
        dizio["pos_visual_Y"]=float(file_db["pos_visual_Y"])
        dizio["nuov_comp"]=int(file_db["nuov_comp"])
        try:
            dizio["prez_mq"]=float(file_db["prez_mq"])
        except:
            dizio["prez_mq"]=200.0
        try:
            dizio["larg_fin"]=int(file_db["larg_fin"])
            dizio["alt_fin"]=int(file_db["alt_fin"])
        except:
            nulla=None
        file_db.close()
    except:
        print "Errore di lettura db"
        traceback.print_exc()
        dizio["num_tot_comp"]=0
        #global num_comp,list_comp
        list_comp =[]
        compon={}
        num_comp=0

def scrittura_dati_3D_db():
    #file_db["lista_propr,%s"%(comp_num)]=list_comp[comp_num]["lista_propr"]
    #file_db["%s,%s,tipo_dato"%(propr,comp_num)]=list_comp[comp_num]["tipi_dati"]
    #file_db["lista_propr_gen"]=dizio["lista_propr_gen"]
    #file_db["%s,tipo_dato"%(propr_gen)]=dizio["tipi_dati_gen"]
    print "scrittura_dati_3D_db()"
    nulla=None
    file_db = anydbm.open(dizio["file_dat_antep_3D_db"],"c")
    print dizio["num_tot_comp"]
    print num_comp
    for comp_num in range(dizio["num_tot_comp"]):
        str_list_prop=""
        for propr in list_comp[comp_num]["lista_propr"]:
            str_list_prop += "%s,"%propr
        file_db["lista_propr,%s"%(comp_num)]=str_list_prop
        num_propr=0
        for propr in list_comp[comp_num]["lista_propr"]:
            file_db["%s,%s,tipo_dato"%(propr,comp_num)]=list_comp[comp_num]["tipi_dati"][num_propr]
            file_db["%s,%s"%(propr,comp_num)]=str(list_comp[comp_num][propr])
            num_propr +=1
        try:file_db["id_img_textu,%s"%(comp_num)]=str(list_comp[comp_num]["id_img_textu"])
        except:traceback.print_exc()
    dizio["tot_num_textu"] = len(lista_perc_textu)
    for num_textu in range(dizio["tot_num_textu"]):
        file_db["lista_perc_textu,%s"%(num_textu)]=str(lista_perc_textu[num_textu])
    str_list_prop_gen=""
    for propr_gen in dizio["lista_propr_gen"]:
        str_list_prop_gen += "%s,"%propr_gen
    file_db["lista_propr_gen"]=str_list_prop_gen
    num_propr_gen = 0
    for propr_gen in dizio["lista_propr_gen"]:
        file_db["%s,tipo_dato"%(propr_gen)]=dizio["tipi_dati_gen"][num_propr_gen]
        file_db[propr_gen]=str(dizio[propr_gen])
        num_propr_gen += 1
    file_db.close()

def scrittura_dati_3D_db_2():
    print "scrittura_dati_3D_db()"
    nulla=None
    #Dati_comp = anydbm.open(dizio["file_dat_antep_3D_db"],"w")
    file_db = anydbm.open(dizio["file_dat_antep_3D_db"],"c")
    print dizio["num_tot_comp"]
    print num_comp
    for comp_num in range(dizio["num_tot_comp"]):
        #file_db["Ditta,%s"%(comp_num)]=list_comp[comp_num]["Ditta"]
        #file_db["num_sot_grup_prod,%s"%(comp_num)]=list_comp[comp_num]["num_sot_grup_prod"]
        #for a in range(list_comp[comp_num]["num_sot_grup_prod"]):
        #    file_db["sot_grup_prod,%s,%s"%(comp_num,a)]=list_comp[comp_num][a]["sot_grup_prod"]
        file_db["Nom_est_prod,%s"%(comp_num)]=list_comp[comp_num]["Nom_est_prod"]
        #file_db["%s,%s"%(propriet[nome_proppiet],comp_num)]=list_comp[comp_num]propriet[nome_proppiet]
        file_db["dim_comp_L,%s"%(comp_num)]=str(list_comp[comp_num]["dim_comp_L"])
        file_db["dim_comp_P,%s"%(comp_num)]=str(list_comp[comp_num]["dim_comp_P"])
        file_db["dim_comp_H,%s"%(comp_num)]=str(list_comp[comp_num]["dim_comp_H"])
        file_db["pos_orig_x,%s"%(comp_num)]=str(list_comp[comp_num]["pos_orig_x"])
        file_db["pos_orig_y,%s"%(comp_num)]=str(list_comp[comp_num]["pos_orig_y"])
        file_db["pos_orig_z,%s"%(comp_num)]=str(list_comp[comp_num]["pos_orig_z"])
        file_db["pos_orig_2_x,%s"%(comp_num)]=str(list_comp[comp_num]["pos_orig_2_x"])
        file_db["pos_orig_2_y,%s"%(comp_num)]=str(list_comp[comp_num]["pos_orig_2_y"])
        file_db["pos_orig_2_z,%s"%(comp_num)]=str(list_comp[comp_num]["pos_orig_2_z"])
        file_db["ang_orig_x,%s"%(comp_num)]=str(list_comp[comp_num]["ang_orig_x"])
        file_db["ang_orig_y,%s"%(comp_num)]=str(list_comp[comp_num]["ang_orig_y"])
        file_db["ang_orig_z,%s"%(comp_num)]=str(list_comp[comp_num]["ang_orig_z"])
        try:file_db["id_img_textu,%s"%(comp_num)]=str(list_comp[comp_num]["id_img_textu"])
        except:traceback.print_exc()
        #file_db["img_textu,%s"%(comp_num)]=str(list_comp[comp_num]["img_textu"])
        #try:file_db["perc_img_textu,%s"%(comp_num)]=str(list_comp[comp_num][lista_perc_textu[list_comp[comp_num]["id_img_textu"]]])
        #except:traceback.print_exc()
        #lista_perc_textu[num_textu]
        #list_comp[dizio["comp_sell"]]["img_textu"]
        #file_db["unit_mis,%s"%(comp_num)]=str(list_comp[comp_num]["unit_mis"])
        #file_db["prez_unit_mis,%s"%(comp_num)]=str(list_comp[comp_num]["prez_unit_mis"])
        #file_db["ID_formula,%s"%(comp_num)]=str(list_comp[comp_num]["ID_formula"])
        #file_db["Kg_unit_mis,%s"%(comp_num)]=str(list_comp[comp_num]["Kg_unit_mis"])
        #file_db["num_lavor_agg,%s"%(comp_num)]=str(list_comp[comp_num]["num_lavor_agg"])
        #for b in range(list_comp[comp_num]["num_lavor_agg"]):
        #    file_db["lavor_agg,%s,%s"%(comp_num,b)]=str(list_comp[comp_num][b]["lavor_agg"])
        #    file_db["temp_lav_unit_mis,%s,%s"%(comp_num,b)]=str(list_comp[comp_num][b]["temp_lav_unit_mis"])
        #for nome_f in range(list_comp[comp_num]formule):
        #    file_db["%s,%s"%(propriet[nome_proppiet],comp_num)]=str(list_comp[comp_num]propriet[nome_proppiet])
        #file_db["temp_unit_mis,%s"%(comp_num)]=str(list_comp[comp_num]["temp_unit_mis"])
    #list_comp[dizio["comp_sell"]]["img_textu"]
    #file_db["immag_sele"]=str(dizio["immag_sele"])
    dizio["tot_num_textu"] = len(lista_perc_textu)
    for num_textu in range(dizio["tot_num_textu"]):
        file_db["lista_perc_textu,%s"%(num_textu)]=str(lista_perc_textu[num_textu])
    file_db["tot_num_textu"]=str(dizio["tot_num_textu"])
    file_db["angolo_visual_X"]=str(dizio["angolo_visual_X"])
    file_db["angolo_visual_Y"]=str(dizio["angolo_visual_Y"])
    file_db["dist_osserv"]=str(dizio["dist_osserv"])
    file_db["pos_visual_X"]=str(dizio["pos_visual_X"])
    file_db["pos_visual_Y"]=str(dizio["pos_visual_Y"])
    file_db["nuov_comp"]=str(dizio["nuov_comp"])
    file_db["num_tot_comp"]=str(dizio["num_tot_comp"])
    file_db["larg_fin"]=str(dizio["larg_fin"])
    file_db["alt_fin"]=str(dizio["alt_fin"])
    file_db.close()

def lettura_dati_3D():
    print 'def lettura_dati_3D():'
    global num_comp,list_comp
    #Funzione per la lettura dei dati per l'anteprima 3D su file *.TXT
    dizio["file_dat_antep_3D"] = "File_dati_anteprima_3D.txt"
    print dizio["file_dat_antep_3D"]
    print os.getcwd()
    file_dat_antep_3D = open(dizio["file_dat_antep_3D"],"r+t")
    testo = file_dat_antep_3D.read()
    num_invio = testo.count("\r\n")
    file_dat_antep_3D.seek(0)
    dizio["Stato_Dim"]=0
    dizio["Stato_file_mat"]=0
    dizio["Stato_compon"]=0
    list_comp=[]
    num_comp=0
    for c in range(num_invio):
        #dizio["dati_3D"] = file_dat_antep_3D.read()
        riga_testo = file_dat_antep_3D.readline()
        #riga_testo = file_dat_antep_3D.read()
        #print riga_testo
        divi_dati_3D_txt(riga_testo,file_dat_antep_3D) 
    file_dat_antep_3D.close()
    #print list_perc_mat[0]
    #print list_perc_mat[1]
    #print list_perc_mat[2]
    #print list_perc_mat[3]
    #print list_perc_mat[4]
    #print list_perc_mat[5]

def divi_dati_3D_txt(riga_testo,file_dat_antep_3D):
    #print 'def divi_dati_3D_txt(riga_testo,file_dat_antep_3D):'
    #Funzione per la divisone-memorizzazione dei dati 3D contenuti nel file *.TXT
    #print "Passato per 'divi_dati_3D_txt()'"
    #print "posizione su testo = "+str(file_dat_antep_3D.tell())
    num_mag = riga_testo.count(">")
    if (num_mag == 1):
        nulla = None
        pos = 0
        if(dizio["Stato_Dim"]==0):
            pos = riga_testo.find("Dim")
            if (pos != -1):
                pos1 = riga_testo.find("(")
                pos2 = riga_testo.find(")")
                dizio_GL["larghe"]=float(riga_testo[pos1+1:pos2].split(",")[0])
                dizio_GL["profon"]=float(riga_testo[pos1+1:pos2].split(",")[1])
                dizio_GL["altez"]=float(riga_testo[pos1+1:pos2].split(",")[2])
                #print dizio_GL["larghe"]
                #print dizio_GL["profon"]
                #print dizio_GL["altez"]
                dizio["Stato_Dim"]=1
        if(dizio["Stato_file_mat"]==0):
            global list_perc_mat
            list_perc_mat=[]
            pos = riga_testo.find("file_mat")
            if (pos != -1):
                while(riga_testo!="\r\n"):
                    riga_testo = file_dat_antep_3D.readline()
                    #print riga_testo
                    pos = riga_testo.find("id_mat_")
                    if(pos != -1):
                        pos = riga_testo.find("=")
                        if(pos != -1):
                            while(riga_testo[pos]==" "):
                                pos+=1
                            list_perc_mat.append(riga_testo[pos+1:-2])
                dizio["Stato_file_mat"]=1
        #print pos
    if (num_mag == 2):
        if(dizio["Stato_compon"]==0):
            global num_comp
            num_comp+=1
            compon={}
            compon["Nom_est_prod"]=riga_testo[2:-3]
            print compon["Nom_est_prod"]
            riga_testo = file_dat_antep_3D.readline()
            pos = riga_testo.find("dim_comp")
            if (pos != -1):
                pos1 = riga_testo.find("(",pos)
                pos2 = riga_testo.find(")",pos)
                compon["dim_comp_L"]=float(riga_testo[pos1+1:pos2].split(",")[0])
                compon["dim_comp_P"]=float(riga_testo[pos1+1:pos2].split(",")[1])
                compon["dim_comp_H"]=float(riga_testo[pos1+1:pos2].split(",")[2])
                print compon["dim_comp_L"]
                print compon["dim_comp_P"]
                print compon["dim_comp_H"]
            pos = riga_testo.find("pos_orig")
            if (pos != -1):
                pos1 = riga_testo.find("(",pos)
                pos2 = riga_testo.find(")",pos)
                compon["pos_orig_x"]=float(riga_testo[pos1+1:pos2].split(",")[0])
                compon["pos_orig_y"]=float(riga_testo[pos1+1:pos2].split(",")[1])
                compon["pos_orig_z"]=float(riga_testo[pos1+1:pos2].split(",")[2])
                print compon["pos_orig_x"]
                print compon["pos_orig_y"]
                print compon["pos_orig_z"]
            pos = riga_testo.find("ang_orig")
            if (pos != -1):
                pos1 = riga_testo.find("(",pos)
                pos2 = riga_testo.find(")",pos)
                compon["ang_orig_x"]=float(riga_testo[pos1+1:pos2].split(",")[0])
                compon["ang_orig_y"]=float(riga_testo[pos1+1:pos2].split(",")[1])
                compon["ang_orig_z"]=float(riga_testo[pos1+1:pos2].split(",")[2])
                print compon["ang_orig_x"]
                print compon["ang_orig_y"]
                print compon["ang_orig_z"]
            list_comp.append(compon)
            #dizio["Stato_compon"]=1
        nulla = None
    if (num_mag == 3):
        nulla = None
    #dizio["dim_prod"] = 
    #file_dat_antep_3D.close()
    #print dizio["dati_3D"]

    

def avvio(dizio_):
    print'def avvio(dizio_):'
    dizio=dizio_
    #def avvio(lumin,larghe,profon,altez):
    lumin = 0.5
    dizio_GL["lumin"] = lumin
    #dizio_GL["larghe"] = float(dizio["Dim_L"].get())
    #dizio_GL["profon"] = float(dizio["Dim_P"].get())
    #dizio_GL["altez"] = float(dizio["Dim_H"].get())
    dizio_GL["larghe"] = float(dizio["Dim_L"])
    dizio_GL["profon"] = float(dizio["Dim_P"])
    dizio_GL["altez"] = float(dizio["Dim_H"])
    #dizio_GL["list_comp_prod"] = dizio["list_comp_prod"].get(0,100)
    #dizio_GL["larghe"] = larghe
    #dizio_GL["profon"] = profon
    #dizio_GL["altez"] = altez
    if (dizio_GL["Fin_att"]==0):
        dizio_GL["Fin_att"] = 1
        print "Anteprima OpenGL"
        #thread.start_new_thread(avvio_,())
        #print "Thread n. ",thread.get_ident()
        avvio_()
    if (dizio_GL["Fin_att"]==2):
        print "Rivisualizza finestra OpenGL"
        dizio_GL["Fin_att"] = 1
        #glutPostRedisplay()
        glutShowWindow()
    if (dizio_GL["Fin_att"]==1):
        print "Aggiorna OpenGL"
        #glutPostRedisplay()
        #costr_3D()
        #display()
        #init()
        
#lumin = 100
#larghe = 0
#profon = 0
#altez = 0

try:
    #percorso attuale su linux della cartella
    #os.chdir('/home1/cona/In_uso_Importanti/Disegni/Realizzazioni/Script in Python/Sistema_preventivi/Su_misura_2007-05-11/Prodotto_OpenGL_2009_05_25')
    os.chdir(perc_prog)
except:
    try:
        #os.chdir('\\\\Cad1\\D\\Script_in_Python\\Su_Misura_(Test_su_Windows)\\')
        #os.chdir('C:\\Script_in_Python\\Su_Misura_3D_OpenGL_Test')
        os.chdir(perc_prog)
    except:    
        print "Errore di percorso corrente"

print os.getcwd()
dizio={}
dizio["Dim_L"]= 200
dizio["Dim_P"]= 70
dizio["Dim_H"]= 90
dizio["perc_prog"]=perc_prog
avvio(dizio)

